unit AboutUnit;

interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls,
  Buttons, ExtCtrls, TypeDefs;

type
  TAboutBox = class(TForm)
    Panel1: TPanel;
    ProgramIcon: TImage;
    ProductName: TLabel;
    VersionLbl: TLabel;
    Copyright: TLabel;
    AckowledgeLbl: TLabel;
    OKButton: TButton;
    Memo1: TMemo;
    Label1: TLabel;
    DateLbl: TLabel;
    Label3: TLabel;
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  AboutBox    : TAboutBox;

implementation

uses Main;

{$R *.DFM}

procedure TAboutBox.FormShow(Sender: TObject);
var
  FDate : integer;
  DT    : tDateTime;
  Y,M,D : word;
begin
  VersionLbl.Caption := VersionStr;
  FDate := FileAge(ParamStr(0));
  DT    := FileDateToDateTime(FDate);
  DecodeDate(DT,Y,M,D);
  DateLbl.Caption := IntToStr(Y) + '/' + IntToStr(M) + '/' + IntToStr(D);
end;

procedure TAboutBox.FormCreate(Sender: TObject);
begin
  ProgramIcon.Picture.Assign(Application.Icon);
end;

end.

