unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, ComCtrls, ToolWin, Menus, ActnList, ImgList, Buttons,
  TypeDefs, CPort, ShlObj;

type
  TMainForm = class(TForm)
    MainMenu1: TMainMenu;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    File1: TMenuItem;
    StatusBar1: TStatusBar;
    Bevel1: TBevel;
    Exit1: TMenuItem;
    View1: TMenuItem;
    BaseLayout1: TMenuItem;
    N640x480: TMenuItem;
    N800x600: TMenuItem;
    FontSizes1: TMenuItem;
    Settings1: TMenuItem;
    Help1: TMenuItem;
    Index1: TMenuItem;
    Contents1: TMenuItem;
    GettingStarted1: TMenuItem;
    N4: TMenuItem;
    About1: TMenuItem;
    ErrorReport1: TMenuItem;
    N5: TMenuItem;
    PlayPopupMenu: TPopupMenu;
    N1024x768: TMenuItem;
    General1: TMenuItem;
    ProjectActions: TActionList;
    NewProject: TAction;
    OpenProject: TAction;
    ImageList1: TImageList;
    SaveProject: TAction;
    SaveProjectAs: TAction;
    NewProject1: TMenuItem;
    OpenProject1: TMenuItem;
    SaveProject1: TMenuItem;
    SaveProjectAs1: TMenuItem;
    Actions1: TMenuItem;
    ActionsActions: TActionList;
    Connect: TAction;
    Reset: TAction;
    LoadS19: TAction;
    SaveS19: TAction;
    LoadS19L: TAction;
    SaveS19L: TAction;
    Connect1: TMenuItem;
    Reset1: TMenuItem;
    LoadS191: TMenuItem;
    SaveS191: TMenuItem;
    N3: TMenuItem;
    N7: TMenuItem;
    Local1: TMenuItem;
    LoadS19L1: TMenuItem;
    SaveS19L1: TMenuItem;
    OutputWindow1: TMenuItem;
    Command1: TMenuItem;
    N10pt1: TMenuItem;
    N12pt1: TMenuItem;
    N10pt2: TMenuItem;
    N12pt2: TMenuItem;
    N14pt2: TMenuItem;
    Converter1: TMenuItem;
    MacroEditor1: TMenuItem;
    SymbolTable1: TMenuItem;
    IORegisters1: TMenuItem;
    Terminal1: TMenuItem;
    N9: TMenuItem;
    VerifyS191: TMenuItem;
    N1: TMenuItem;
    Macro2: TMenuItem;
    Talkers1: TMenuItem;
    VerifyS19: TAction;
    Macro1: TMenuItem;
    MacroActions: TActionList;
    NewMacro: TAction;
    OpenMacro: TAction;
    SaveMacro: TAction;
    SaveMacroAs: TAction;
    PlayMacro: TAction;
    StopMacro: TAction;
    EditMacro: TAction;
    RecordAdd: TAction;
    New1: TMenuItem;
    Open1: TMenuItem;
    Save1: TMenuItem;
    SaveAs1: TMenuItem;
    N2: TMenuItem;
    RecordAdd1: TMenuItem;
    Play1: TMenuItem;
    Stop1: TMenuItem;
    Edit1: TMenuItem;
    EditPopupMenu: TPopupMenu;
    CHEditPopup: TPopupMenu;
    SelectAll1: TMenuItem;
    Copy1: TMenuItem;
    SelectAll2: TMenuItem;
    Copy2: TMenuItem;
    HelponErrorMsg1: TMenuItem;
    COMPort1: TMenuItem;
    Reopen1: TMenuItem;
    N08pt1: TMenuItem;
    MemoryMap1: TMenuItem;
    WatchEditPopup: TPopupMenu;
    Add1: TMenuItem;
    Delete1: TMenuItem;
    ClearAll1: TMenuItem;
    Undelete1: TMenuItem;
    N10: TMenuItem;
    Refresh1: TMenuItem;
    N11: TMenuItem;
    VerifyS19L: TAction;
    VerifyS19vLocal1: TMenuItem;
    ClearWindow1: TMenuItem;
    Memory1: TMenuItem;
    Import1: TMenuItem;
    N12: TMenuItem;
    LoadBinary1: TMenuItem;
    SaveBinary1: TMenuItem;
    N13: TMenuItem;
    N14: TMenuItem;
    LoadBinaryL1: TMenuItem;
    SaveBinaryL1: TMenuItem;
    SidebarPanel: TPanel;
    CPUGroupBox: TGroupBox;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label4: TLabel;
    Label11: TLabel;
    AEdit: TEdit;
    IXEdit: TEdit;
    IYEdit: TEdit;
    BEdit: TEdit;
    Panel11: TPanel;
    PCLbl: TLabel;
    TGLbl1: TLabel;
    TGPanel1: TPanel;
    TGLbl: TLabel;
    LULbl1: TLabel;
    LUPanel1: TPanel;
    LULbl: TLabel;
    CCRPanel: TPanel;
    CCRLblC: TLabel;
    CCRLblV: TLabel;
    CCRLblZ: TLabel;
    CCRLblN: TLabel;
    CCRLblI: TLabel;
    CCRLblH: TLabel;
    CCRLblX: TLabel;
    CCRLblS: TLabel;
    Panel1: TPanel;
    ConnectBtn: TSpeedButton;
    ResetBtn: TSpeedButton;
    OpenS19Btn: TSpeedButton;
    SaveS19Btn: TSpeedButton;
    PlayBtn: TSpeedButton;
    PlayMenuBtn: TBitBtn;
    RecordBtn: TSpeedButton;
    StopBtn: TSpeedButton;
    EditBtn: TSpeedButton;
    Panel2: TPanel;
    Splitter1: TSplitter;
    OWEdit: TRichEdit;
    CHEdit: TMemo;
    CmdEdit: TEdit;
    SwitchBtn: TSpeedButton;
    Splitter2: TSplitter;
    Terminate1: TMenuItem;
    BootScript1: TMenuItem;
    N8: TMenuItem;
    CrcS19: TAction;
    CrcS19L: TAction;
    CrcS19L1: TMenuItem;
    CrcS191: TMenuItem;
    Notes1: TMenuItem;
    Debug1: TMenuItem;
    BPDisplayPopUp: TPopupMenu;
    Add3: TMenuItem;
    Delete3: TMenuItem;
    ClearAll3: TMenuItem;
    ResetPassCount3: TMenuItem;
    Panel3: TPanel;
    BPPanel: TPanel;
    WatchPanel: TPanel;
    Splitter3: TSplitter;
    StartBreakPointLbl: TLabel;
    WatchListBox: TListBox;
    WatchLbl: TLabel;
    BPListBox: TListBox;
    N15: TMenuItem;
    N16: TMenuItem;
    Type1: TMenuItem;
    Address1: TMenuItem;
    OrderAdded1: TMenuItem;
    N6: TMenuItem;
    SPEdit: TEdit;
    WordWrap1: TMenuItem;
    CopytoMacroEditor1: TMenuItem;
    Overlays1: TMenuItem;
    LoadBin: TAction;
    SaveBin: TAction;
    LoadBinL: TAction;
    SaveBinL: TAction;
    IndMem1: TMenuItem;
    Indirect1: TMenuItem;
    LoadS192: TMenuItem;
    SaveasS191: TMenuItem;
    LoadBinary2: TMenuItem;
    SaveasBinary1: TMenuItem;
    LoadS19Ind: TAction;
    LoadBinInd: TAction;
    SaveIndS19: TAction;
    SaveIndBin: TAction;
    N18: TMenuItem;
    ClearWindow2: TMenuItem;
    ColorDialog1: TColorDialog;
    Colors1: TMenuItem;
    SetbitsinRegsDisplay1: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure SettingsClick(Sender: TObject);
    procedure CmdEditKeyPress(Sender: TObject; var Key: Char);
    procedure FormShow(Sender: TObject);
    procedure SizeClick(Sender: TObject);
    procedure CmdEditKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure CmdEditKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure CHEditClick(Sender: TObject);
    procedure CHEditDblClick(Sender: TObject);
    procedure WindowSaveClick(Sender: TObject);
    procedure ClearOutputWindow1Click(Sender: TObject);
    procedure ClearCommandHistory1Click(Sender: TObject);
    procedure NewProjectExecute(Sender: TObject);
    procedure OpenProjectExecute(Sender: TObject);
    procedure SaveProjectExecute(Sender: TObject);
    procedure SaveProjectAsExecute(Sender: TObject);
    procedure ConnectExecute(Sender: TObject);
    procedure ResetExecute(Sender: TObject);
    procedure LoadS19Execute(Sender: TObject);
    procedure SaveS19Execute(Sender: TObject);
    procedure View1Click(Sender: TObject);
    procedure VerifyS19Execute(Sender: TObject);
    procedure NewMacroExecute(Sender: TObject);
    procedure OpenMacroExecute(Sender: TObject);
    procedure SaveMacroExecute(Sender: TObject);
    procedure SaveMacroAsExecute(Sender: TObject);
    procedure RecordAddExecute(Sender: TObject);
    procedure PlayMacroExecute(Sender: TObject);
    procedure StopMacroExecute(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure StopBtnClick(Sender: TObject);
    procedure RecordBtnClick(Sender: TObject);
    procedure PlayBtnClick(Sender: TObject);
    procedure EditBtnClick(Sender: TObject);
{On-the-fly submenu click handlers}
    procedure ReopenMenuClick(Sender: TObject);
    procedure MacroListMenuClick(Sender: TObject);
    procedure OWFontClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure Exit1Click(Sender: TObject);
    procedure MemoryMap1Click(Sender: TObject);
    procedure InhRegEditExit(Sender: TObject);
    procedure InhRegEditEnter(Sender: TObject);
    procedure InhRegEditKeyPress(Sender: TObject; var Key: Char);
    procedure Add1Click(Sender: TObject);
    procedure WatchEditChange(Sender: TObject);
    procedure Converter1Click(Sender: TObject);
    procedure SymbolTable1Click(Sender: TObject);
    procedure IORegisters1Click(Sender: TObject);
    procedure WatchListBoxExit(Sender: TObject);
    procedure WatchListBoxDragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure WatchListBoxDragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure ClearAll1Click(Sender: TObject);
    procedure Undelete1Click(Sender: TObject);
    procedure Delete1Click(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure HelponErrorMsg1Click(Sender: TObject);
    procedure CHEditPopupPopup(Sender: TObject);
    procedure SelectAll2Click(Sender: TObject);
    procedure Copy2Click(Sender: TObject);
    procedure SelectAll1Click(Sender: TObject);
    procedure Copy1Click(Sender: TObject);
    procedure DoIdle(Sender: TObject; var Done: Boolean);
    procedure MacroEditor1Click(Sender: TObject);
    procedure Refresh1Click(Sender: TObject);
    procedure WatchEditPopupPopup(Sender: TObject);
    procedure ErrorReport1Click(Sender: TObject);
    procedure Index1Click(Sender: TObject);
    procedure Contents1Click(Sender: TObject);
    procedure GettingStarted1Click(Sender: TObject);
    procedure ClearWindow1Click(Sender: TObject);
    procedure Import1Click(Sender: TObject);
    procedure PlayMenuBtnClick(Sender: TObject);
    procedure Macro1Click(Sender: TObject);
    procedure File1Click(Sender: TObject);
    procedure CCRLblDblClick(Sender: TObject);
    procedure Splitter2CanResize(Sender: TObject; var NewSize: Integer;
      var Accept: Boolean);
    procedure Splitter1CanResize(Sender: TObject; var NewSize: Integer;
      var Accept: Boolean);
    procedure Terminate1Click(Sender: TObject);
    procedure SwitchBtnClick(Sender: TObject);
    procedure CrcS19Execute(Sender: TObject);
    procedure Terminal1Click(Sender: TObject);
    procedure Add3Click(Sender: TObject);
    procedure BPDisplayPopUpPopup(Sender: TObject);
    procedure BPListBoxDrawItem(Control: TWinControl; Index: Integer;
      Rect: TRect; State: TOwnerDrawState);
    procedure SortByClick(Sender: TObject);
    procedure BPListBoxExit(Sender: TObject);
    procedure Delete3Click(Sender: TObject);
    procedure ClearAll3Click(Sender: TObject);
    procedure ResetPassCount3Click(Sender: TObject);
    procedure RegEditKeyPress(Sender: TObject; var Key: Char);
    procedure WordWrap1Click(Sender: TObject);
    procedure RegEditChange(Sender: TObject);
    procedure CopytoMacroEditor1Click(Sender: TObject);
    procedure CHEditExit(Sender: TObject);
    procedure CHEditKeyPress(Sender: TObject; var Key: Char);
    procedure EditPopupMenuPopup(Sender: TObject);
    procedure Settings1Click(Sender: TObject);
    procedure Help1Click(Sender: TObject);
    procedure SaveBinExecute(Sender: TObject);
    procedure LoadBinExecute(Sender: TObject);
    procedure WhatsThisPopup(Sender: TObject);
    procedure Whatsthis1Click(Sender: TObject);
    procedure ClearWindow2Click(Sender: TObject);
    procedure OutputWindow1Click(Sender: TObject);
    procedure Command1Click(Sender: TObject);
    procedure CHFontClick(Sender: TObject);
    procedure SetColorClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
{The following dodge adds a progress bar to a status bar. I got it from:
 Athena's Place by Alex Simonetti Abreu, see:
 http://www.bhnet.com.br/~simonet/tipstricks/progressbar.htm}
    ProgressBar1: TProgressBar;
  end;

function  RemoveErrMsg(S : string) : string;

var
  MainForm                 : TMainForm;
//  PFListMenu,MacroListMenu : array of tMenuItem;

implementation

uses
  FileUnit, CFGUnit, MiscUnit, SettingsUnit, CheckUnit, InitUnit, MemUnit,
  AddToWatchUnit, CalcUnit, SymbolUnit, AboutUnit, VIUnit, CmdUnit,
  SaveUnit, MacroUnit, Comms1, ERUnit, ImportUnit, MemRW, BPUnit, TermUnit,
  AddBPUnit, RunTraceUnit, LoadUnit;

{$R *.DFM}

var
  LastEditText,WatchListText : string;
  HasVer4Info                : boolean;
  WhatsThisSender            : tObject;

{Miscellaneous procedures ----------------------------------------------------}

function  RemoveErrMsg(S : string) : string;
var
  ArrowPos : integer;
begin
  Result   := S;
  ArrowPos := pos(' <--',Result);
  if ArrowPos > 0 then delete(Result,ArrowPos,length(Result)-ArrowPos+1);
end; // function RemoveErrMsg

{Form event handlers ---------------------------------------------------------}

procedure TMainForm.DoIdle(Sender: TObject; var Done: Boolean);
begin
  Application.OnIdle := nil;
  if ProjData.AutoConnectAtStartup
  then begin
    CmdEdit.Text := 'CONNECT';
    ProcessCR;
  end;
end; // procedure TMainForm.DoIdle

procedure TMainForm.FormCreate(Sender: TObject);
var
  ProgressBarStyle : LongInt;
  DummyStr1,DummyStr2,DummyStr3 : string;
begin
{Add a progress bar to the status bar - see note in declaration of
 ProgressBar1 above}
  ProgressBar1 := TProgressBar.Create(MainForm); // .Create(StatusBar1);
  with ProgressBar1 do
  begin
    Parent := StatusBar1;
{remove progress bar border}
    ProgressBarStyle := GetWindowLong(ProgressBar1.Handle, GWL_EXSTYLE);
    ProgressBarStyle := ProgressBarStyle - WS_EX_STATICEDGE;
    SetWindowLong(ProgressBar1.Handle, GWL_EXSTYLE, ProgressBarStyle);
{set progress bar position and size - put in Panel[2]}
    Left   := StatusBar1.Panels.Items[0].Width +
                       StatusBar1.Panels.Items[1].Width + 4;
    Top    := 4;
    Height := StatusBar1.Height - 6;
    Width  := StatusBar1.Panels.Items[2].Width - 6;
{set range and initial state}
    Min      := 0;
    Max      := 100;
    Step     := 1;
    Position := 0;
    Smooth   := true;
  end;  

{Filling these arrays with $00 ensures that illegal opcodes will be
 flagged by having nil pointers in the arrays}
  fillchar(OpcodePage1,sizeof(OpcodePage1),0);
  fillchar(OpcodePage2,sizeof(OpcodePage2),0);
  fillchar(OpcodePage3,sizeof(OpcodePage3),0);
  fillchar(OpcodePage4,sizeof(OpcodePage4),0);

{Local copy of MCU and indirect memory to start off blank}
  fillchar(Memory,sizeof(Memory),0);
  fillchar(IndMemory,sizeof(IndMemory),0);

{Initialize the memory maps}
  MemMap        := tList.Create;
  MemMap.Clear;
  IndMemMap     := tList.Create;
  IndMemMap.Clear;

{Initialize the breakpoint list}
  BPList        := tList.Create;
  BPList.Capacity := 6;

{Instantiate the various string lists}
  UndeleteList    := tStringList.Create;
  Ports           := tStringList.Create;
  S19Listing      := tStringList.Create;
  PFList          := tStringList.Create;
  EEOvlyListing   := tStringList.Create;
  EOvlyListing    := tStringList.Create;
  ByteOvlyListing := tStringList.Create;
  PageOvlyListing := tStringList.Create;
  IndRegsOvlyListing := tStringList.Create;
  IndMemOvlyListing  := tStringList.Create;
  TalkerOverlainListing := tStringList.Create;

  MacroNameList   := tStringList.Create;
  SymbolTable     := nil;

{Fill in various initial values}
  LaunchDirFull := ExtractFileDir(Application.ExeName);
  MyDocsDirFull := GetSpecialFolder(CSIDL_PERSONAL);
  EnumComPorts(Ports);
  Ports.Sorted  := true;
  SupErrMsg     := '';
  SupErrMsgSet  := false;

{Build the version information}
  VersionInfo   := tVersionInfo.Create(MainForm);
  with VersionInfo do
  begin
    ThisVersion := IntToStr(MajorVersion) + '.' + IntToStr(MinorVersion);
    WorkRoot    := RegRoot + ThisVersion + '\';
    VersionStr  := IntToStr(MajorVersion) + '.' +
                   IntToStr(MinorVersion) + '.' +
                   IntToStr(ReleaseVersion) + '.' +
                   format('%4.4d',[Build]);
  end;
  ReadInRoot  := WorkRoot; // this will be changed if an earlier version found

{Get the desktop centre}
  with Screen do
  begin
    DesktopCentre.x := DesktopLeft + (DesktopWidth div 2);
    DesktopCentre.y := DesktopTop  + (DesktopHeight div 2);
  end;

{Check whether Version 4xx registry information exists}
  HasVer4Info := GetRootNames(DummyStr1,DummyStr2,DummyStr3);

{Create the Prog variable}
  Prog          := tProg.Create;

{Set the Help file}
  if FileExists(LaunchDirFull + '\Help\' + FN_Help)
  then Application.HelpFile := LaunchDirFull + '\Help\' + FN_Help;

{If this is the first time of use, associate the project file extension
 with the project executable}
  if not RegEntryExists then SetupFileAssociation;

{Update the Registry keys if this is a higher minor version number}
  UpdateRegInfo;

{Set up the Application idle event handler}
  Application.OnIdle := DoIdle;
end; // procedure TMainForm.FormCreate

procedure TMainForm.FormShow(Sender: TObject);
var
  FN_StartupProj   : string;
  NeedToSaveOnExit : boolean;
begin
{Replace tokens in DefaultProjData with full paths}
  DetokenizeDefaultData;
{Initialize Prog data}
  with Prog do
  begin
    TGAddr     := $FFFF;
    LUAddr     := 0;
    BRAddr     := $FFFF;
    State      := psDuffData;
    MacroState := msStopped;
  end;
  ReadGeneral(ReadInRoot,FN_StartupProj);
{If the project file is on the command line, it supersedes the one in the
 Registry, which was read in by ReadGeneral above}
  if (ParamCount > 0) and FileExists(ParamStr(1))
  then FN_StartupProj := ParamStr(1);
{Read in the project file}
  if OpenProjectFileOK(FN_StartupProj,NeedToSaveOnExit)
  then begin
    Prog.ProjectHasChanged := NeedToSaveOnExit;
    ReopenMacroAndSymbol;
    Prog.State := psDisconnected;
  end
  else begin
    Prog.State := psDuffData;
  end;

{It appears to be necessary to set font sizes _after_ the components are
 visible}  
  OWEdit.Font.Size := OWFontSize;
  SetOWTabs;
  CHEdit.Font.Size  := CHFontSize;
  CmdEdit.Font.Size := CHFontSize;

  if ShowMEForm     then MEForm.Show;
  if ShowSymbolForm then ShowSymbols;
  if ShowCalcForm   then CalcForm.Show;
  if ShowMapForm    then MapForm.Show;
  CmdEdit.SetFocus;
end; // procedure TMainForm.FormShow

procedure TMainForm.FormDestroy(Sender: TObject);
begin
  UndeleteList.Free;
  Ports.Free;
  S19Listing.Free;
  PFList.Free;
  EEOvlyListing.Free;
  EOvlyListing.Free;
  ByteOvlyListing.Free;
  PageOvlyListing.Free;
  IndRegsOvlyListing.Free;
  IndMemOvlyListing.Free;
  TalkerOverlainListing.Free;
  Prog.Free;
  ClearMemMap(MemMap);
  MemMap.Free;
  IndMemMap.Free;
  ClearBPList;
  BPList.Free;
  VersionInfo.Free;
  MacroNameList.Free;
{Tidy up the reopen menu items}
  FreeSubMenu(Reopen1);
{Tidy up the play macro menu items}
  FreeSubMenu(Play1);
end; // procedure TMainForm.FormDestroy

{Edit box event handlers -----------------------------------------------------}

procedure TMainForm.CmdEditKeyPress(Sender: TObject; var Key: Char);
begin
  if Key = chr($0D) // 'enter' key processes the command
  then begin
    ProcessCR;
    CHEdit.SelStart := length(CHEdit.Text);
{The underlying Windows routine does not accept VK_RETURN as a valid key stroke
 in a TEdit type control, and therefore issues an error message.  If the
 computer is set to 'beep on error' then pressing 'Return' will generate an
 annoying beep.  Following line simply re-assigns the key to suppress this.
 See the Borland Community KB article 0,1410,16773,00}
    Key := Chr(0);
  end; // if Key = chr($0D)
{Ditto the above explanation in the case of the 'Escape' key}  
  if Key = chr($1B) // 'escape' key clears the command line or stops macro
  then begin
    if Prog.MacroState <> msStopped
    then begin
      MacroNestingCount := 0;
      Prog.MacroState   := msStopped;
    end
    else begin
      CmdEdit.Clear;
      Key := Chr(0);
      CHEdit.SelStart := length(CHEdit.Text);
      LastCommand     := cmdNone;
    end; // if Prog.MacroState <> msStopped
  end; // if Key = chr($1B)
end;

procedure TMainForm.CmdEditKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  with CHEdit do
  begin
    if Key = VK_UP
    then begin
      if LastCmdIndex > 0
      then begin
        LastCmdIndex := LastCmdIndex - 1;
        CmdEdit.Text := RemoveErrMsg(Lines[LastCmdIndex]);
      end;
    end; // if Key = VK_UP then..
    if Key = VK_DOWN
    then begin
      if LastCmdIndex < Lines.Count-1
      then begin
        LastCmdIndex := LastCmdIndex + 1;
        CmdEdit.Text := RemoveErrMsg(Lines[LastCmdIndex]);
      end
      else begin
        CmdEdit.Text := '';
      end;
    end; // if Key = VK_DOWN then.. else..
  end; // with CHEdit do
end; // procedure TMainForm.CmdEditKeyDown

procedure TMainForm.CmdEditKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if (Key = VK_UP) or (Key = VK_DOWN)
  then CmdEdit.SelStart := length(CmdEdit.Text);
end; // procedure TMainForm.CmdEditKeyUp

procedure TMainForm.CHEditClick(Sender: TObject);
begin
  with CHEdit do
  begin
// EM_EXLINEFROMCHAR has the value WM_USER + 54 = 1024 + 54 = 1078  
{Discover the line containing SelStart}
    CHEditStartRow := SendMessage(Handle,EM_LINEFROMCHAR,SelStart,0);

{Discover the line containing SelStart+SelLength}
    CHEditEndRow   := SendMessage(Handle,EM_LINEFROMCHAR,SelStart+SelLength,0);

{Discover the character index at the start of the line containing SelStart}
    CHEditStartChar := SendMessage(Handle,EM_LINEINDEX,CHEditStartRow,0);

{Discover the character index at the end of the line containing
 SelStart+ SelLength}
    CHEditEndChar   := SendMessage(Handle,EM_LINEINDEX,CHEditEndRow+1,0) - 2;

    SelStart  := CHEditStartChar;
    SelLength := CHEditEndChar - CHEditStartChar;
  end; //
  CmdEdit.Text := RemoveErrMsg(CHEdit.Lines[CHEditStartRow]);
  CmdEdit.SelectAll;
//  CmdEdit.SetFocus;
end; // TMainForm.CHEditClick

procedure TMainForm.CHEditDblClick(Sender: TObject);
begin
  ProcessCR;
  CmdEdit.SelStart := length(CmdEdit.Text);
  CmdEdit.SetFocus;
end; // procedure TMainForm.CHEditDblClick

{Menu item handlers ----------------------------------------------------------}

procedure TMainForm.WindowSaveClick(Sender: TObject);
begin
end; // procedure TMainForm.WindowSaveClick

procedure TMainForm.ClearOutputWindow1Click(Sender: TObject);
begin
  OWEDit.Clear;
end; // procedure TMainForm.ClearOutputWindow1Click

procedure TMainForm.ClearCommandHistory1Click(Sender: TObject);
begin
  CHEdit.Clear;
end; // procedure TMainForm.ClearCommandHistory1Click

procedure TMainForm.SizeClick(Sender: TObject);
var
  LayoutInfo : tLayoutRec;
begin
  if Sender = N640x480  then LayoutInfo := Layout6x4;
  if Sender = N800x600  then LayoutInfo := Layout8x6;
  if Sender = N1024x768 then LayoutInfo := Layout10x7;
  with LayoutInfo do
  begin
    with MainForm do
    begin
      Left               := MainLeft;
      Top                := MainTop;
      Width              := MainWidth;
      Height             := MainHeight;
      CHEdit.Height      := CHEditHeight;
      SidebarPanel.Width := SidebarWidth;
    end;
    with MEForm do
    begin
      Left   := MacroLeft;
      Top    := MacroTop;
      Width  := MacroWidth;
      Height := MacroHeight;
    end; // with MEForm do

    with SymbolForm do
    begin
      Left   := SymbolLeft;
      Top    := SymbolTop;
      Height := SymbolHeight;
    end; // with SymbolForm do

    with CalcForm do
    begin
      Left   := ConverterLeft;
      Top    := ConverterTop;
    end; // with ConverterForm do
  end;  

  OWEdit.Repaint;
  CHEdit.Repaint;
  CHEdit.SelStart := length(Text);
  CmdEdit.SetFocus;
end; // procedure TMainForm.SizeClick

{Project Action handlers -----------------------------------------------------}

procedure TMainForm.NewProjectExecute(Sender: TObject);
begin
  if Prog.MacroHasChanged
  then begin
    case PromptToSaveMacro(stNewProject) of
      mrYes    : begin
                   if FileExists(ProjData.FN_Macro)
                   then SaveMacroExecute(nil)
                   else SaveMacroAsExecute(nil)
                 end;
      mrNo     : begin end;
    end; // case PromptToSaveMacro of
  end; // if MacroHasChanged then..

  if Prog.ProjectHasChanged
  then begin
    case PromptToSaveProject(stNew) of
      mrYes    : begin
                   if length(ExtractFileName(Prog.FN_Project)) = 0
                   then SaveProjectAsExecute(nil)
                   else SaveProjectExecute(nil)
                 end;
      mrNo     : begin end;
      mrCancel : exit;
    end; // case PromptToSaveProject of
  end; // if DataHasChanged then..

  Prog.FN_Project := '';
  ProjData := DefaultProjData;
  Prog.ProjectHasChanged := false;
  WatchListBox.Clear;
  SettingsForm.PageControl1.ActivePage := SettingsForm.GeneralTab;
  SettingsForm.ShowModal;
end; // procedure TMainForm.NewProjectExecute

procedure TMainForm.OpenProjectExecute(Sender: TObject);
var
  Buf : string;
  NeedToSaveOnExit : boolean;
begin
  if Prog.MacroHasChanged
  then begin
    case PromptToSaveMacro(stNewProject) of
      mrYes    : begin
                   if FileExists(ProjData.FN_Macro)
                   then SaveMacroExecute(nil)
                   else SaveMacroAsExecute(nil)
                 end;
      mrNo     : begin end;
    end; // case PromptToSaveMacro of
  end; // if MacroHasChanged then..

  if Prog.ProjectHasChanged
  then begin
    case PromptToSaveProject(stOpen) of
      mrYes    : begin
                   if length(ExtractFileName(Prog.FN_Project)) = 0
                   then SaveProjectAsExecute(nil)
                   else SaveProjectExecute(nil)
                 end;
      mrNo     : begin end;
      mrCancel : exit;
    end; // case PromptToSaveProject of
  end; // if DataHasChanged then..

  Buf := Prog.FN_Project;
  if length(Buf) = 0
  then Buf := LaunchDirFull + '\Project\';
  if OpenDialogOK(Buf,ftProject)
  then begin
    if CommsForm.ComPort.Connected
    then begin
      CmdEdit.Text := 'DISCONNECT';
      ProcessCR;
    end;
    if OpenProjectFileOK(Buf,NeedToSaveOnExit)
    then begin
      Prog.ProjectHasChanged := NeedToSaveOnExit;
      ReopenMacroAndSymbol;
      Prog.State := psDisconnected;
    end
    else Prog.State := psDuffData;
  end; //
end; // procedure TMainForm.OpenProjectExecute

procedure TMainForm.SaveProjectExecute(Sender: TObject);
begin
  WriteProjectFile(ProjData,Prog.FN_Project);
  Prog.ProjectHasChanged := false;
  OWEdit.Lines.Add('Saved project: ' + ExtractFileName(Prog.FN_Project));
end; // procedure TMainForm.SaveProjectExecute

procedure TMainForm.SaveProjectAsExecute(Sender: TObject);
var
  Buf : string;
begin
  Buf := Prog.FN_Project;
  if length(Buf) = 0
  then Buf := LaunchDirFull + '\Project\';
  if SaveAsDialogOK(Buf,ftProject)
  then begin
    Prog.FN_Project := Buf;
    WriteProjectFile(ProjData,Prog.FN_Project);
    Prog.ProjectHasChanged := false;
    OWEdit.Lines.Add('Project saved as: ' + ExtractFileName(Prog.FN_Project));
  end;
end; // procedure TMainForm.SaveProjectAsExecute

{Action Action Handlers -----------------------------------------------------}

procedure TMainForm.ConnectExecute(Sender: TObject);
begin
  if CommsForm.ComPort.Connected
  then CmdEdit.Text := 'DISCONNECT'
  else CmdEdit.Text := 'CONNECT';
  ProcessCR;
  Delay(100);
end; // procedure TMainForm.ConnectExecute

procedure TMainForm.ResetExecute(Sender: TObject);
begin
  CmdEdit.Text := 'RESET';
  ProcessCR;
end; // procedure TMainForm.ResetExecute

procedure TMainForm.LoadS19Execute(Sender: TObject);
var
  FName,Buf : string;
begin
  FName := DetokenizeFileName(ProjData.FN_LoadS19);
  if OpenDialogOK(FName,ftS19)
  then begin
    if uppercase(ProjData.FN_LoadS19) <> uppercase(FName)
    then Prog.ProjectHasChanged := true;
    ProjData.FN_LoadS19 := FName;

    if Sender = LoadS19    then Buf := 'LD';
    if Sender = LoadS19L   then Buf := 'LDL';
    if Sender = LoadS19Ind then Buf := 'LDI';
    CmdEdit.Text := Buf + ' "' + TokenizeFileName(FName) + '"';
    ProcessCR;
  end;
end; // procedure TMainForm.LoadS19Execute

procedure TMainForm.LoadBinExecute(Sender: TObject);
var
  FName,Buf : string;
begin
  FName := DetokenizeFileName(ProjData.FN_LoadBinary);
  if OpenDialogOK(FName,ftBinary)
  then begin
    if LoadAddrForm.ShowModal = mrCancel then exit;
    if Sender = LoadBin    then Buf := 'LD';
    if Sender = LoadBinL   then Buf := 'LDL';
    if Sender = LoadBinInd then Buf := 'LDI';
    CmdEdit.Text := Buf +
                    ' "' + TokenizeFileName(FName) + '" ' +
                    LoadAddrForm.LoadAddrEdit.Text;
    ProcessCR;
  end;
{If all OK so far, update the project record of the file name}
  if uppercase(ProjData.FN_LoadBinary) <> uppercase(FName)
  then Prog.ProjectHasChanged := true;
  ProjData.FN_LoadBinary := FName;
end; // procedure TMainForm.LoadBinExecute

procedure TMainForm.SaveS19Execute(Sender: TObject);
var
  FName,Buf : string;
begin
  if SaveAddrForm.ShowModal = mrCancel then exit;
  FName := DetokenizeFileName(ProjData.FN_LoadS19);
  if SaveDialogOK(FName,ftS19)
  then begin
    with SaveAddrForm do
    begin
      if Sender = SaveS19    then Buf := 'SV ';
      if Sender = SaveS19L   then Buf := 'SVL ';
      if Sender = SaveIndS19 then Buf := 'SVI ';
      CmdEdit.Text :=
        Buf + FromAddrEdit.Text + ' ' + ToAddrEdit.Text +
        ' "' + TokenizeFileName(FName) + '"';
    end;
    ProcessCR;
  end;
{If all OK so far, update the project record of the file name}
  if uppercase(ProjData.FN_LoadS19) <> uppercase(FName)
  then Prog.ProjectHasChanged := true;
  ProjData.FN_LoadS19 := FName;
end; // procedure TMainForm.SaveS19Execute

procedure TMainForm.SaveBinExecute(Sender: TObject);
var
  FName,Buf : string;
begin
  if SaveAddrForm.ShowModal = mrCancel then exit;
  FName := DetokenizeFileName(ProjData.FN_LoadBinary);
  if SaveDialogOK(FName,ftBinary)
  then begin
    with SaveAddrForm do
    begin
      if Sender = SaveBin    then Buf := 'SV ';
      if Sender = SaveBinL   then Buf := 'SVL ';
      if Sender = SaveIndBin then Buf := 'SVI ';
      CmdEdit.Text :=
        Buf + FromAddrEdit.Text + ' ' + ToAddrEdit.Text +
        ' "' + TokenizeFileName(FName) + '"';
    end;
    ProcessCR;
  end;
{If all OK so far, update the project record of the file name}
  if uppercase(ProjData.FN_LoadBinary) <> uppercase(FName)
  then Prog.ProjectHasChanged := true;
  ProjData.FN_LoadBinary := FName;
end; // procedure TMainForm.SaveBinExecute

procedure TMainForm.VerifyS19Execute(Sender: TObject);
var
  FName,Buf : string;
begin
  FName := DetokenizeFileName(ProjData.FN_LoadS19);
  if OpenDialogOK(FName,ftS19)
  then begin
    FName := TokenizeFileName(FName);
    if Sender = VerifyS19 then Buf := 'V "';
    if Sender = VerifyS19L then Buf := 'VL "';
    CmdEdit.Text := Buf + FName + '"';
    ProcessCR;
  end;
end; // procedure TMainForm.VerifyS19Execute

procedure TMainForm.CrcS19Execute(Sender: TObject);
var
  FName,Buf : string;
begin
  FName := DetokenizeFileName(ProjData.FN_LoadS19);
  if OpenDialogOK(FName,ftS19)
  then begin
    FName := TokenizeFileName(FName);
    if Sender = CrcS19 then Buf := 'CRC "';
    if Sender = CrcS19L then Buf := 'CRCL "';
    CmdEdit.Text := Buf + FName + '"';
    ProcessCR;
  end;
end; // procedure TMainForm.CrcS19Execute

{Main Menu top line item click handlers --------------------------------------}

procedure TMainForm.File1Click(Sender: TObject);
var
  i     : integer;
  MItem : tMenuItem;
begin
  File1.HelpContext       := IDH_FILE_MENU;
{Enable and disable Actions}
  SaveProject.Enabled := (length(Prog.FN_Project) > 0) and Prog.ProjectHasChanged;
  Import1.Enabled     := HasVer4Info;
{Build the 'Reopen' sub-menu}
  FreeSubMenu(Reopen1);
  for i := 0 to (PFList.Count - 1) do
  begin
    MItem := tMenuItem.Create(MainMenu1);
    MItem.Caption := ExtractFileName(PFList[i]);
    MItem.Hint    := PFList[i];
    MItem.OnClick := ReopenMenuClick;
    Reopen1.Add(MItem);
  end;
  if (Reopen1.Count > 0) and (Reopen1[0].Hint = Prog.FN_Project)
  then Reopen1[0].Enabled := false;
  Reopen1.Enabled := PFList.Count > 0;
end; // procedure TMainForm.File1Click

procedure TMainForm.View1Click(Sender: TObject);
begin
  View1.HelpContext       := IDH_VIEW_MENU;
{Checked status of font choices}
  N08pt1.Checked := (OWEdit.DefAttributes.Size = 8);
  N10pt1.Checked := (OWEdit.DefAttributes.Size = 10);
  N12pt1.Checked := (OWEdit.DefAttributes.Size = 12);
  N10pt2.Checked := (CmdEdit.Font.Size = 10);
  N12pt2.Checked := (CmdEdit.Font.Size = 12);
  N14pt2.Checked := (CmdEdit.Font.Size = 14);
end; // procedure TMainForm.MainMenuClick

procedure TMainForm.Macro1Click(Sender: TObject);
var
  MItem : tMenuItem;
  i     : integer;
begin
  Macro1.HelpContext := IDH_MACRO_MENU;
  SaveMacro.Enabled := Prog.MacroHasChanged;
{Build the 'Play Macro' sub-menu}
  FreeSubMenu(Play1);
  if NameListNeedsRebuilding then BuildMacroNameList;
  for i := 0 to (MacroNameList.Count - 1) do
  begin
    MItem := tMenuItem.Create(MainMenu1);
    MItem.Caption := MacroNameList[i];
    MItem.OnClick := MacroListMenuClick;
    Play1.Add(MItem);
  end;
  Play1.Enabled := Play1.Count > 0;
end; // procedure TMainForm.Macro1Click

procedure TMainForm.Settings1Click(Sender: TObject);
begin
  Settings1.HelpContext   := IDH_SETTINGS_MENU;
end; // procedure TMainForm.Settings1Click

procedure TMainForm.Help1Click(Sender: TObject);
begin
  Help1.HelpContext := IDH_HELP_MENU;
end; // procedure TMainForm.Help1Click

{Other Speedbutton click event handlers -------------------------------------}

procedure TMainForm.PlayMenuBtnClick(Sender: TObject);
var
  MItem : tMenuItem;
  i     : integer;
begin
  FreeMainMenu(PlayPopupMenu);
  if NameListNeedsRebuilding then BuildMacroNameList;
  for i := 0 to (MacroNameList.Count - 1) do
  begin
    MItem := tMenuItem.Create(PlayPopupMenu);
    MItem.Caption := MacroNameList[i];
    MItem.OnClick := MacroListMenuClick;
    PlayPopupMenu.Items.Add(MItem);
  end;
  PlayPopupMenu.Popup(MainForm.Left+PlayBtn.Left+4,MainForm.Top+82);
end; // procedure TMainForm.PlayMenuBtnClick

procedure TMainForm.SwitchBtnClick(Sender: TObject);
begin
  if SwitchSignalActive
  then CmdEdit.Text := 'SWITCH OFF'
  else CmdEdit.Text := 'SWITCH ON';
  ProcessCR;
end; // procedure TMainForm.SwitchBtnClick

{Pop-up menu event handlers -------------------------------------------------}

procedure TMainForm.ReopenMenuClick(Sender: TObject);
var
  Buf     : string;
  NeedToSaveOnExit : boolean;
begin
  if CommsForm.ComPort.Connected
  then begin
    CmdEdit.Text := 'DISCONNECT';
    ProcessCR;
  end;  
  Buf := (Sender as tMenuItem).Hint;
  if OpenProjectFileOK(Buf,NeedToSaveOnExit)
  then begin
    Prog.ProjectHasChanged := NeedToSaveOnExit;
    ReopenMacroAndSymbol;
  end
  else Prog.State := psDuffData;
end; // procedure TMainForm.ReopenMenuClick

procedure TMainForm.MacroListMenuClick(Sender: TObject);
var i : integer;
begin
  PlayMacroName := (Sender as tMenuItem).Caption;
{Following line fixes a sort of bug, whereby List.Caption has ampersands
 inserted automatically to provide for mouse-free operation}
  i := pos('&',PlayMacroName);
  if i > 0 then delete(PlayMacroName,i,1);
  CmdEdit.Text  := PlayMacroName;
  ProcessCR;
  PlayBtn.Hint  := 'Play Macro: ' + PlayMacroName;
end; // procedure TMainForm.MacroListMenuClick

procedure TMainForm.NewMacroExecute(Sender: TObject);
begin
  with ProjData do
  begin
    if Prog.MacroHasChanged
    then begin
      case PromptToSaveMacro(stNew) of
        mrYes    : if FileExists(FN_Macro)
                   then MEForm.MEEdit.Lines.SaveToFile(FN_Macro)
                   else SaveMacroAsExecute(nil);
        mrNo     : begin end;
        mrCancel : exit;
      end; // case PromptToSaveMacro of
    end; // if MacroHasChanged then..
    ProjData.FN_Macro := '';
    MEForm.MEEdit.Clear;
    BuildMacroNameList;
    Prog.MacroHasChanged := false;
  end; // with Prog,ProjData do
end; // procedure TMainForm.NewMacroExecute

procedure TMainForm.OpenMacroExecute(Sender: TObject);
var
  Buf : string;
begin
  with Prog do
  begin
    if MacroHasChanged
    then begin
      case PromptToSaveMacro(stNew) of
        mrYes    : if FileExists(ProjData.FN_Macro)
                   then MEForm.MEEdit.Lines.SaveToFile(ProjData.FN_Macro)
                   else SaveMacroAsExecute(nil);
        mrNo     : begin end;
        mrCancel : exit;
      end; // case PromptToSaveMacro of
    end; // if MacroHasChanged

    Buf := ProjData.FN_Macro;
    if not FileExists(Buf) then Buf := MyDocsDirFull + '\';
    if OpenDialogOK(Buf,ftMacro)
    then begin
      MEForm.MEEdit.Lines.LoadFromFile(Buf);
      BuildMacroNameList;
      if uppercase(Buf) <> uppercase(ProjData.FN_Macro)
      then ProjectHasChanged := true;
      ProjData.FN_Macro := Buf;
      MacroHasChanged   := false;
    end; //
  end; // with Prog do
end; // procedure TMainForm.OpenMacroExecute

procedure TMainForm.SaveMacroExecute(Sender: TObject);
begin
  if not FileExists(ProjData.FN_Macro)
  then SaveMacroAsExecute(nil)
  else begin
    MEForm.MEEdit.Lines.SaveToFile(ProjData.FN_Macro);
    Prog.MacroHasChanged := false;
  end;
end; // procedure TMainForm.SaveMacroExecute

procedure TMainForm.SaveMacroAsExecute(Sender: TObject);
var
  Buf : string;
begin
  with Prog do
  begin
    Buf := ProjData.FN_Macro;
    if length(Buf) = 0
    then Buf := ExtractFilePath(ProjData.FN_Macro); // MyDocsDirFull + '\';
    if SaveAsDialogOK(Buf,ftMacro)
    then begin
      ProjData.FN_Macro := Buf;
      if uppercase(Buf) <> uppercase(ProjData.FN_Macro)
      then ProjectHasChanged := true;
      ProjData.FN_Macro := Buf;
      MEForm.MEEdit.Lines.SaveToFile(ProjData.FN_Macro);
      MacroHasChanged := false;
    end;
  end; // with Prog do
end; // procedure TMainForm.SaveMacroAsExecute

procedure TMainForm.RecordAddExecute(Sender: TObject);
begin
  Prog.MacroState := msRecording;
end; // procedure TMainForm.RecordAddExecute

procedure TMainForm.PlayMacroExecute(Sender: TObject);
begin
  if length(PlayMacroName) > 0
  then begin
    CmdEdit.Text := PlayMacroName;
    ProcessCR;
  end;  
end; // procedure TMainForm.PlayMacroExecute

procedure TMainForm.StopMacroExecute(Sender: TObject);
begin
  Prog.MacroState := msStopped;
end; // procedure TMainForm.StopMacroExecute

procedure TMainForm.FormResize(Sender: TObject);
begin
  StatusBar1.Panels[0].Width := MainForm.Width - 273;
  ProgressBar1.Left := StatusBar1.Panels.Items[0].Width +
                       StatusBar1.Panels.Items[1].Width + 4;
end;

procedure TMainForm.PlayBtnClick(Sender: TObject);
begin
  if PlayBtn.Down and (length(PlayMacroName) > 0)
  then PlayMacro.Execute else StopMacro.Execute;
end; // procedure TMainForm.PlayBtnClick

procedure TMainForm.RecordBtnClick(Sender: TObject);
begin
  if RecordBtn.down
  then begin
    RecordAdd.Execute;
  end
  else begin
    StopMacro.Execute;
  end; // if RecordBtn down then.. else..
end; // procedure TMainForm.RecordBtnClick

procedure TMainForm.StopBtnClick(Sender: TObject);
begin
  StopMacro.Execute;
end; // procedure TMainForm.StopBtnClick

procedure TMainForm.EditBtnClick(Sender: TObject);
begin
  EditMacro.Execute;
end; // procedure TMainForm.EditBtnClick

procedure TMainForm.SettingsClick(Sender: TObject);
begin
  with SettingsForm do
  begin
    if Sender = General1     then PageControl1.ActivePage := GeneralTab;
    if Sender = COMPort1     then PageControl1.ActivePage := COMPortTab;
    if (Sender = Macro2) or (Sender = BootScript1)
                             then PageControl1.ActivePage := MacrosTab;
    if Sender = Debug1       then PageControl1.ActivePage := DebugTab;
    if Sender = Talkers1     then PageControl1.ActivePage := TalkersTab;
    if Sender = Overlays1    then PageControl1.ActivePage := OverlaysTab;
    if Sender = Memory1      then PageControl1.ActivePage := MemoryTab;
    if Sender = Notes1       then PageControl1.ActivePage := NotesTab;
    if Sender = IndMem1      then PageControl1.ActivePage := IndirectTab;
    ShowModal;
  end;
end; // procedure TMainForm.General1Click

procedure TMainForm.OWFontClick(Sender: TObject);
begin
  if Sender = N08pt1 then OWFontSize :=  8;
  if Sender = N10pt1 then OWFontSize := 10;
  if Sender = N12pt1 then OWFontSize := 12;
  OWEdit.Font.Size := OWFontSize;
  SetOWTabs;
end; // procedure TMainForm.FontClick

procedure TMainForm.CHFontClick(Sender: TObject);
begin
  if Sender = N10pt2 then CHFontSize :=  10;
  if Sender = N12pt2 then CHFontSize :=  12;
  if Sender = N14pt2 then CHFontSize :=  14;
  CHEdit.Font.Size         := CHFontSize;
  CmdEdit.Font.Size        := CHFontSize;
end; // procedure TMainForm.CHFontClick

procedure TMainForm.OutputWindow1Click(Sender: TObject);
begin
  N08pt1.Checked := (OWFontSize = 8);
  N10pt1.Checked := (OWFontSize = 10);
  N12pt1.Checked := (OWFontSize = 12);
end; // procedure TMainForm.OutputWindow1Click

procedure TMainForm.Command1Click(Sender: TObject);
begin
  N10pt2.Checked := (CHFontSize = 10);
  N12pt2.Checked := (CHFontSize = 12);
  N14pt2.Checked := (CHFontSize = 14);
end; // procedure TMainForm.Command1Click

procedure TMainForm.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  CanClose := true;

  if Prog.MacroHasChanged
  then begin
    case PromptToSaveMacro(stClose) of
      mrYes    : begin
                   if FileExists(ProjData.FN_Macro)
                   then SaveMacroExecute(nil)
                   else SaveMacroAsExecute(nil)
                 end;
      mrNo     : begin end;
      mrCancel : begin CanClose := false; exit; end;
    end; // case PromptToSaveMacro of
  end; // if MacroHasChanged then..

  if Prog.ProjectHasChanged
  then begin                                       
    case PromptToSaveProject(stClose) of
      mrYes    : begin
                   if FileExists(Prog.FN_Project)
                   then SaveProjectExecute(nil)
                   else SaveProjectAsExecute(nil)
                 end;
      mrNo     : begin end;
      mrCancel : begin CanClose := false; exit; end;
    end; // case PromptToSaveProject of
  end; // if DataHasChanged then..
end; // procedure TMainForm.FormCloseQuery

procedure TMainForm.Exit1Click(Sender: TObject);
begin
  MainForm.Close;
end; // procedure TMainForm.Exit1Click

procedure TMainForm.Terminate1Click(Sender: TObject);
begin
  Application.Terminate;
end; // procedure TMainForm.Terminate1Click

procedure TMainForm.MemoryMap1Click(Sender: TObject);
begin
  MapForm.Show;
end; // procedure TMainForm.MemoryMap1Click

procedure TMainForm.InhRegEditEnter(Sender: TObject);
begin
  LastEditText := (Sender as tEdit).Text;
end; // procedure TMainForm.InhRegEditEnter

procedure TMainForm.InhRegEditExit(Sender: TObject);
begin
  if length((Sender as tEdit).Text) = 0
  then begin
    MessageDlg('Edit box must not be left blank',mtError,[mbOK],0);
    (Sender as tEdit).Text := LastEditText;
    (Sender as tEdit).SetFocus;
  end;
end; // procedure TMainForm.InhRegEditExit

procedure TMainForm.InhRegEditKeyPress(Sender: TObject; var Key: Char);
begin
  {Always allow the backspace, return and tab keys}
  if (Key = ^H) or (Key = ^M) or (Key = ^I) then exit;
  if not (Key in HexChars) then Key := chr(0);
end; // procedure TMainForm.InhRegEditKeyPress

procedure TMainForm.WatchEditChange(Sender: TObject);
begin
  Prog.ProjectHasChanged := true;
end; // procedure TMainForm.WatchEditChange

procedure TMainForm.Converter1Click(Sender: TObject);
begin
  CalcForm.Show;
end; // procedure TMainForm.Converter1Click

procedure TMainForm.SymbolTable1Click(Sender: TObject);
begin
  ShowSymbols;
end; // procedure TMainForm.SymbolTable1Click

procedure TMainForm.IORegisters1Click(Sender: TObject);
begin
  ShowRegisters;
end; // procedure TMainForm.IORegisters1Click

procedure TMainForm.WatchListBoxExit(Sender: TObject);
begin
  WatchListBox.ItemIndex := -1;
end; // procedure TMainForm.WatchListBoxExit

procedure TMainForm.WatchListBoxDragDrop(Sender, Source: TObject; X,
  Y: Integer);
begin
  with (Sender as TListBox) do
      Items.Move(ItemIndex,ItemAtPos(Point(x,y),True));
end; //  procedure TMainForm.WatchListBoxDragDrop

procedure TMainForm.WatchListBoxDragOver(Sender, Source: TObject; X,
  Y: Integer; State: TDragState; var Accept: Boolean);
begin
  Accept := (Sender=Source);
end; // procedure TMainForm.WatchListBoxDragOver

procedure TMainForm.About1Click(Sender: TObject);
begin
  AboutBox.ShowModal;
end; // procedure TMainForm.About1Click

procedure TMainForm.CHEditPopupPopup(Sender: TObject);
begin
  HelponErrorMsg1.Enabled :=
    (CHEdit.SelLength > 1) and           
    (CHEditStartRow = CHEditEndRow) and    // i.e. only one line selected
    (pos('<--',CHEdit.SelText) > 0)        // and has an error message
end;

procedure TMainForm.SelectAll2Click(Sender: TObject);
begin
  CHEdit.SelectAll;
end; // procedure TMainForm.SelectAll2Click

procedure TMainForm.Copy2Click(Sender: TObject);
begin
  CHEdit.CopyToClipboard;
end; // procedure TMainForm.Copy2Click

procedure TMainForm.CopytoMacroEditor1Click(Sender: TObject);
begin
  MEForm.MEEdit.Lines.Add(CHEdit.SelText);
  MEForm.Show;
end; // procedure TMainForm.CopytoMacroEditor1Click

procedure TMainForm.HelponErrorMsg1Click(Sender: TObject);
var
  ErrPos     : integer;
  ErrMsg     : string;
  CLC        : tCmdLineComment;
begin
  ErrPos := pos('<--',CHEdit.SelText) + 1;
  if (ErrPos = 1) or (ErrPos > length(CHEdit.SelText)) then exit;
  ErrMsg := copy(CHEdit.SelText,ErrPos+3,length(CHEdit.SelText)-ErrPos-2);
  CLC := clcCmdErr;
  while CLC < clcLast do begin
    if CommentArray[CLC] = ErrMsg then break;
    inc(CLC);
  end;
  if CLC = clcLast then exit;
  Application.HelpContext(IDH_____UNRECOGNIZED_COMMAND + ord(CLC) - 2)
end; // procedure TMainForm.HelponErrorMsg1Click

procedure TMainForm.ClearWindow2Click(Sender: TObject);
begin
  CHEdit.Clear;
  CmdEdit.SetFocus;
end; // procedure TMainForm.ClearWindow2Click

procedure TMainForm.SelectAll1Click(Sender: TObject);
begin
  OWEdit.SelectAll;
end; // procedure TMainForm.SelectAll1Click

procedure TMainForm.Copy1Click(Sender: TObject);
begin
  OWEdit.CopyToClipboard;
end; // procedure TMainForm.Copy1Click

procedure TMainForm.MacroEditor1Click(Sender: TObject);
begin
  MEForm.Show;
end; // procedure TMainForm.MacroEditor1Click

{Watch window context menu **************************************************}

procedure TMainForm.WatchEditPopupPopup(Sender: TObject);
var
  Flag : boolean;
begin
  Flag := WatchListBox.Items.Count > 0;
  Refresh1.Enabled  := (Prog.State >= psStopped) and Flag;
  Delete1.Enabled   := WatchListBox.ItemIndex >= 0;
  ClearAll1.Enabled := Flag;
end; // procedure TMainForm.WatchEditPopupPopup

procedure TMainForm.Refresh1Click(Sender: TObject);
begin
  RefreshWatch;
end; // procedure TMainForm.Refresh1Click

procedure TMainForm.Add1Click(Sender: TObject);
begin
  if AddToWatchForm.ShowModal = mrYes then SymbolForm.SetFocus;
end; // procedure TMainForm.Add1Click

procedure TMainForm.Delete1Click(Sender: TObject);
var
  i : integer;
begin
  with WatchListBox do
  begin
    WatchListText := Items.Text;
    i := ItemIndex;
    if i >= 0
    then begin
      UndeleteList.Add(Items[i]);
      Items.Delete(i);
      if i < Items.Count then ItemIndex := i else ItemIndex := Items.Count - 1;
    end;
    if WatchListText <> Items.Text then Prog.ProjectHasChanged := true;
  end;
end; // procedure TMainForm.Delete1Click

procedure TMainForm.ClearAll1Click(Sender: TObject);
begin
  WatchListText := WatchListBox.Items.Text;
  UndeleteList.AddStrings(WatchListBox.Items);
  WatchListBox.Clear;
  if WatchListText <> WatchListBox.Items.Text
  then Prog.ProjectHasChanged := true;
end; // procedure TMainForm.ClearAll1Click

procedure TMainForm.Undelete1Click(Sender: TObject);
begin
  WatchListText := WatchListBox.Items.Text;
  WatchListBox.Items.AddStrings(UndeleteList);
  UndeleteList.Clear;
  if WatchListText <> WatchListBox.Items.Text
  then Prog.ProjectHasChanged := true;
end; // procedure TMainForm.Undelete1Click

procedure TMainForm.ErrorReport1Click(Sender: TObject);
begin
  ERDialog.ShowModal;
end; // procedure TMainForm.ErrorReport1Click

procedure TMainForm.Index1Click(Sender: TObject);
begin
  Application.HelpCommand(HELP_TAB, -2);        // Open with 'Find' tab
end; // procedure TMainForm.Index1Click

procedure TMainForm.Contents1Click(Sender: TObject);
begin
  Application.HelpCommand(HELP_TAB,  0);        // Open with 'Contents' tab
end; // procedure TMainForm.Contents1Click

procedure TMainForm.GettingStarted1Click(Sender: TObject);
begin
  Application.HelpContext(IDH_GETTING_STARTED);
end; // procedure TMainForm.GettingStarted1Click

procedure TMainForm.ClearWindow1Click(Sender: TObject);
begin
  OWEdit.Clear;
  CmdEdit.SetFocus;
end; // procedure TMainForm.ClearAll2Click

procedure TMainForm.Import1Click(Sender: TObject);
begin
  ImportForm.ShowModal;
end; // procedure TMainForm.Import1Click

procedure TMainForm.CCRLblDblClick(Sender: TObject);
var
  BPptr : tBPRecordPtr;
begin
  with Sender as tLabel do
  begin
    if Tag = 1
    then begin Tag := 0; Font.Color := clSilver; Font.Style := []; end
    else begin Tag := 1; Font.Color := clBlack;  Font.Style := [fsBold]; end;
  end;
{Update BP window}
  if RetrieveBP(Prog.BRAddr,[bpTransient,bpFixed,bpPass],BPptr)
  then begin
    DiscoverNext(BPptr^,Prog.StackFrame,false);
    UpdateBPWindow;
  end;
end; // procedure TMainForm.CCRLblCDblClick

procedure TMainForm.Splitter2CanResize(Sender: TObject;
  var NewSize: Integer; var Accept: Boolean);
begin
  Accept := (NewSize < (MainForm.Width - 409)) and (NewSize >= 181);
end; // procedure TMainForm.Splitter2CanResize

procedure TMainForm.Splitter1CanResize(Sender: TObject;
  var NewSize: Integer; var Accept: Boolean);
begin
  Accept := (NewSize < (Panel2.Height - 84)) and (NewSize >= 84);
end; // procedure TMainForm.Splitter1CanResize

procedure TMainForm.Terminal1Click(Sender: TObject);
begin
  CmdEdit.Text := 'TERM';
  ProcessCR;
end;

procedure TMainForm.Add3Click(Sender: TObject);
begin
  AddBPForm.ShowModal;
end;

procedure TMainForm.BPDisplayPopUpPopup(Sender: TObject);
var Flag : boolean;
begin
  Flag := Prog.State in [psStopped,psRunStop,psTraceStop];
  Add3.Enabled := Flag;
  with BPListBox do
  begin
    Delete3.Enabled         := Flag and (ItemIndex >= 0) and
                               (copy(Items[ItemIndex],2,1) <> '(') and
                               (copy(Items[ItemIndex],2,1) <> '>');
    ClearAll3.Enabled       := Flag and (Items.Count > 0);
    ResetPassCount3.Enabled := Flag and (Items.Count > 0);
  end;
  Type1.Checked       := BPSortOrder = soType;
  Address1.Checked    := BPSortOrder = soAddress;
  OrderAdded1.Checked := BPSortOrder = soOrderAdded;
end;

procedure TMainForm.BPListBoxDrawItem(Control: TWinControl; Index: Integer;
  Rect: TRect; State: TOwnerDrawState);
type
  tLineType = (ltPlain,ltStart,ltBreak,ltNext0,ltNext1,ltNext2);
var
  Buf         : string;
  LB          : tListBox;
  LineType    : tLineType;
  Addr1L,Addr2L,AddrW : integer;
const
  AltColor : tColor = clSilver;
begin
  if Index = -1 then exit;
  LB := TListBox(Control);
  if Rect.Top > LB.Height then exit;
  Buf := LB.Items[Index];
  LB.Canvas.Brush.Color := LB.Color;
  LB.Canvas.Font        := LB.Font;
  LineType              := ltPlain;

  
  if copy(Buf,2,1) = '('
  then LineType := ltStart
  else begin
    if copy(Buf,2,1) = '>'
    then begin
      case Buf[1] of
        '0' : LineType := ltNext0;
        '1' : LineType := ltNext1;
        '2' : LineType := ltNext2;
      end;
      Buf[1] := ' ';
    end // if copy(Buf,2,1) = '>' then..
    else begin
      if copy(Buf,3,4) = BRAddrStr
      then LineType := ltBreak
      else LineType := ltPlain;
    end;
  end;    

  case LineType of
    ltStart : LB.Canvas.Font.Color  := clGreen;
    ltBreak : LB.Canvas.Font.Color  := clRed;
    ltNext0,ltNext1,ltNext2 : LB.Canvas.Font.Color  := AltColor;
  end;

  if odSelected in State then
  begin
    case LineType of
      ltPlain :
        begin
          LB.Canvas.Brush.Color := clBlue;
          LB.Canvas.Font.Color  := clWhite;
        end;
      ltStart,ltNext0,ltNext1,ltNext2 : begin end;
      ltBreak :
        begin
          LB.Canvas.Brush.Color := clPurple;
          LB.Canvas.Font.Color  := clWhite;
        end;
    end;
  end;

  LB.Canvas.FillRect(Rect);

  DrawText(LB.Canvas.Handle,PChar(Buf),Length(Buf),Rect,DT_EDITCONTROL);

{If Addr = Prog.BRAddr then overwrite the clSiver address with clBlack}
  if LineType in [ltNext1,ltNext2]
  then begin
    Addr1L := LB.Canvas.TextWidth(' >');
    Addr2L := LB.Canvas.TextWidth(' >1234/');
    AddrW  := LB.Canvas.TextWidth('1234');
    case LineType of
      ltNext1 :
        begin
          Rect.Left  := Rect.Left + Addr1L;
          Buf := copy(Buf,3,4);
        end;
      ltNext2 :
        begin
          Rect.Left  := Rect.Left + Addr2L;
          Buf := copy(Buf,8,4);
        end;
    end;
    Rect.Right := Rect.Left + AddrW;
    LB.Canvas.Font.Color := clBlack;
    DrawText(LB.Canvas.Handle,PChar(Buf),Length(Buf),Rect,DT_EDITCONTROL);
  end; // if LineType in [ltNext1,ltNext2]
end; // procedure TMainForm.BPListBoxDrawItem

procedure TMainForm.SortByClick(Sender: TObject);
begin
  if Sender = Type1       then BPSortOrder := soType;
  if Sender = Address1    then BPSortOrder := soAddress;
  if Sender = OrderAdded1 then BPSortOrder := soOrderAdded;
  UpdateBPWindow;
end; //

procedure TMainForm.BPListBoxExit(Sender: TObject);
begin
  (Sender as tListBox).ItemIndex := -1;
end; // procedure TMainForm.BPListBoxExit

procedure TMainForm.Delete3Click(Sender: TObject);
var
  DelAddr : word;
  BPptr   : tBPRecordPtr;
begin
  with BPListBox do
  begin
    if ItemIndex < 0 then exit;
    DelAddr := StrToInt('$0' + copy(Items[ItemIndex],3,4));
    if not RetrieveBP(DelAddr,[bpTransient,bpFixed,bpPass],BPptr)
    then exit
    else DeleteBPATAddr(DelAddr,[bpTransient,bpFixed,bpPass]);
  end;
  UpdateBPWindow;
end; // procedure TMainForm.Delete3Click

procedure TMainForm.ClearAll3Click(Sender: TObject);
begin
  DeleteBPbyType([bpTransient,bpFixed,bpPass]);
  UpdateBPWindow;
end; // procedure TMainForm.ClearAll3Click

procedure TMainForm.ResetPassCount3Click(Sender: TObject);
begin
  ResetAllPassCounts;
  UpdateBPWindow;
end; // procedure TMainForm.ResetPassCount3Click

procedure TMainForm.RegEditKeyPress(Sender: TObject; var Key: Char);
begin
{Always allow the backspace, return and tab keys}
  if (Key = ^H) or (Key = ^I) then exit;
  if (Key = ^M) then CmdEdit.SetFocus; 
  if not (Key in HexChars) then Key := chr(0);
end;

procedure TMainForm.WordWrap1Click(Sender: TObject);
begin
  OWEdit.WordWrap := not OWEdit.WordWrap;
  OWEdit.SelStart := length(OWEdit.Text);
end; // procedure TMainForm.WordWrap1Click

procedure TMainForm.SetColorClick(Sender: TObject);
begin
  if Sender = SetbitsinRegsDisplay1
  then begin
    ColorDialog1.Color       := BoldColor;
    ColorDialog1.HelpContext := IDH_COLORING__SET__BITS;
    if ColorDialog1.Execute then BoldColor := ColorDialog1.Color;
  end;
end; // procedure TMainForm.BoldColoring1Click

procedure TMainForm.RegEditChange(Sender: TObject);
var BPptr : tBPRecordPtr;
begin
  if SuppressOnChange then exit;
{Update BP window}
  if RetrieveBP(Prog.BRAddr,[bpTransient,bpFixed,bpPass],BPptr)
  then begin
    DiscoverNext(BPptr^,Prog.StackFrame,false);
    UpdateBPWindow;
  end;
end; // procedure TMainForm.RegEditChange

procedure TMainForm.CHEditExit(Sender: TObject);
begin
  CHEdit.SelStart := length(CHEdit.Text);
end; // procedure TMainForm.CHEditExit

procedure TMainForm.CHEditKeyPress(Sender: TObject; var Key: Char);
begin
  case Key of
    ^M :
      begin
        CmdEdit.SetFocus;
        ProcessCR;
      end;
    chr($1B) :
      begin
        CmdEdit.Clear;
        CmdEdit.SetFocus;
      end;
  end;
end; // procedure TMainForm.CHEditKeyPress

procedure TMainForm.EditPopupMenuPopup(Sender: TObject);
begin
  WordWrap1.Checked := OWEdit.WordWrap;
end; // procedure TMainForm.EditPopupMenuPopup

procedure TMainForm.WhatsThisPopup(Sender: TObject);
begin
  WhatsThisSender := Sender;
end; // procedure TMainForm.WhatsThisPopup

procedure TMainForm.Whatsthis1Click(Sender: TObject);
var
  Msg : string;
begin
  if WhatsThisSender = CPUGroupBox
  then Msg := 'Display of the CPU Inherent Registers';
  if WhatsThisSender = StartBreakPointLbl
  then Msg := 'Display of starting and breaking addresses and instructions';
  if WhatsThisSender = WatchLbl
  then Msg := 'Window to watch memory location values during tracing';
  if (WhatsThisSender = TGLbl1) or (WhatsThisSender = TGPanel1)
  then Msg := 'Default address at which Tracing or Going (Running) will begin';
  if (WhatsThisSender = LULbl1) or (WhatsThisSender = LUPanel1)
  then Msg := 'Default address at which Listing or Unassembling will begin';
end; // procedure TMainForm.Whatsthis1Click

end.

