unit SettingsUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, ExtCtrls, Buttons, CPort, TypeDefs, Menus, StdActns,
  ActnList, ECombo;

type
  TSettingsForm = class(TForm)
    PageControl1: TPageControl;
    GeneralTab: TTabSheet;
    MacrosTab: TTabSheet;
    Label7: TLabel;
    OKBtn: TBitBtn;
    CancelBtn: TBitBtn;
    HelpBtn: TBitBtn;
    GroupBox3: TGroupBox;
    Label19: TLabel;
    Label20: TLabel;
    BytesToListEdit: TEdit;
    LinesToUnassembleEdit: TEdit;
    GroupBox4: TGroupBox;
    FormatAbortChkBox: TCheckBox;
    FailureAbortChkBox: TCheckBox;
    NotesTab: TTabSheet;
    COMPortTab: TTabSheet;
    Label23: TLabel;
    PortToUseComboBox: TComboBox;
    GroupBox6: TGroupBox;
    RemoteResetChkBox: TCheckBox;
    GroupBox7: TGroupBox;
    RemoteSwitchChkBox: TCheckBox;
    Panel5: TPanel;
    Using1Lbl: TLabel;
    ResetDTRRadBtn: TRadioButton;
    ResetRTSRadBtn: TRadioButton;
    Panel6: TPanel;
    WithLbl: TLabel;
    PosPulseLbl: TLabel;
    NegPulseLbl: TLabel;
    ResetPosRadBtn: TRadioButton;
    ResetNegRadBtn: TRadioButton;
    Panel7: TPanel;
    Using2Lbl: TLabel;
    ModeDTRRadBtn: TRadioButton;
    ModeRTSRadBtn: TRadioButton;
    Panel8: TPanel;
    IsPositiveLbl: TLabel;
    SelectedWhenPosRadBtn: TRadioButton;
    SelectedWhenNegRadBtn: TRadioButton;
    Panel1: TPanel;
    AutoConnectChkBox: TCheckBox;
    AutoResetChkBox: TCheckBox;
    Label2: TLabel;
    GroupBox2: TGroupBox;
    UpLbl: TLabel;
    CoLbl: TLabel;
    UploadBaudEdit: TEdit;
    CommsBaudEdit: TEdit;
    TkUpDn: TUpDown;
    CoUpDn: TUpDown;
    TalkersTab: TTabSheet;
    MemoryTab: TTabSheet;
    UseRamTalkerRadBtn: TRadioButton;
    UseExternalTalkerRadBtn: TRadioButton;
    UseEepromTalkerRadBtn: TRadioButton;
    MaskRomVisibleChkBox: TCheckBox;
    RamPanel: TPanel;
    RamTalkerLbl: TLabel;
    RamTalkerEdit: TEdit;
    RamTalkerBtn: TButton;
    RamMapLbl: TLabel;
    RamMapEdit: TEdit;
    RamMapBtn: TButton;
    EepromPanel: TPanel;
    EepromMapLbl: TLabel;
    EepromMapEdit: TEdit;
    EepromMapBtn: TButton;
    ExternalPanel: TPanel;
    ExternalMapLbl: TLabel;
    ExternalMapEdit: TEdit;
    ExternalMapBtn: TButton;
    RequiresLbl: TLabel;
    ExtUsesRamBootRadBtn: TRadioButton;
    ExtUsesEepromBootRadBtn: TRadioButton;
    ExtUsesNoBootRadBtn: TRadioButton;
    Label12: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    Label18: TLabel;
    Label15: TLabel;
    Label21: TLabel;
    Label22: TLabel;
    Label24: TLabel;
    Label25: TLabel;
    RegInfoEdit: TEdit;
    RegOpenBtn: TButton;
    Label26: TLabel;
    OpcodeInfoEdit: TEdit;
    OpcodeOpenBtn: TButton;
    ClearAllMemBtn: TButton;
    EepromVisibleChkBox: TCheckBox;
    EpromVisibleChkBox: TCheckBox;
    Label27: TLabel;
    PageWriteVisibleChkBox: TCheckBox;
    PageWriteMemo: TMemo;
    DpsLbl: TLabel;
    DataPageSizeComboBox: TComboBox;
    Label14: TLabel;
    RamEdit: TEdit;
    CtrlRegsEdit: TEdit;
    MaskRomEdit: TEdit;
    EepromEdit: TEdit;
    ExtRamMemo: TMemo;
    ExtRamVisibleChkBox: TCheckBox;
    Label4: TLabel;
    EpromMemo: TMemo;
    NotesMemo: TMemo;
    Label5: TLabel;
    WarnOnBprotChkBox: TCheckBox;
    WarnOnVprogChkBox: TCheckBox;
    BootScriptMemo: TMemo;
    AssocMacroChkBox: TCheckBox;
    NoAutoStartChkBox: TCheckBox;
    Label1: TLabel;
    Bevel1: TBevel;
    AltModeLbl: TLabel;
    WhenLbl: TLabel;
    IsNegativeLbl: TLabel;
    DebugTab: TTabSheet;
    CodeBreakSpaceChkBox: TCheckBox;
    NoVectorSubsChkBox: TCheckBox;
    GroupBox1: TGroupBox;
    ShowStartInstChkBox: TCheckBox;
    ShowStartRegsChkBox: TCheckBox;
    ShowBreakInstChkBox: TCheckBox;
    ShowBreakRegsChkBox: TCheckBox;
    ShowOnceOnlyChkBox: TCheckBox;
    AssociateBtn: TButton;
    NoBreakHandshakeChkBox: TCheckBox;
    SymbolTableGroupBox: TGroupBox;
    AsS19Lbl: TLabel;
    NoSymbolRadBtn: TRadioButton;
    AsS19RadBtn: TRadioButton;
    FromFileRadBtn: TRadioButton;
    SymbolFileEdit: TEdit;
    OpenSymbolBtn: TButton;
    NotInStepOverChkBox: TCheckBox;
    PopupMenu1: TPopupMenu;
    WordWrap1: TMenuItem;
    Label3: TLabel;
    ByteWriteMemo: TMemo;
    ByteWriteVisibleChkBox: TCheckBox;
    OverlaysTab: TTabSheet;
    Panel2: TPanel;
    EepromOverlayLbl: TLabel;
    EepromOverlayEdit: TEdit;
    EepromOverlayBtn: TButton;
    EpromOverlayLbl: TLabel;
    EpromOverlayEdit: TEdit;
    EpromOverlayBtn: TButton;
    ByteWriteLbl: TLabel;
    ByteWriteEdit: TEdit;
    ByteWriteBtn: TButton;
    PageWriteLbl: TLabel;
    PageWriteEdit: TEdit;
    PageWriteBtn: TButton;
    Label6: TLabel;
    WaitForEchoChkBox: TCheckBox;
    N1: TMenuItem;
    Copy1: TMenuItem;
    Cut1: TMenuItem;
    Paste1: TMenuItem;
    ActionList1: TActionList;
    EditCut1: TEditCut;
    EditCopy1: TEditCopy;
    EditPaste1: TEditPaste;
    PopupMenu2: TPopupMenu;
    WordWrap2: TMenuItem;
    N2: TMenuItem;
    Copy2: TMenuItem;
    Cut2: TMenuItem;
    Paste2: TMenuItem;
    EditCut2: TEditCut;
    EditCopy2: TEditCopy;
    EditPaste2: TEditPaste;
    MCUComboBox: TEComboBox;  // See TermSettingsUnit for note on TEComboBox
    Label8: TLabel;
    XtalComboBox: TEComboBox; // See TermSettingsUnit for note on TEComboBox
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label13: TLabel;
    IgnoreEchoErrorsChkBox: TCheckBox;
    Label28: TLabel;
    IndirectTab: TTabSheet;
    GroupBox5: TGroupBox;
    IndMemoryMemo: TMemo;
    IMVisibleChkBox: TCheckBox;
    Label33: TLabel;
    IMPageSizeComboBox: TComboBox;
    GroupBox8: TGroupBox;
    SPISerialLbl: TLabel;
    IndMemOvlyEdit: TEdit;
    IndMemOvlyBtn: TButton;
    Label31: TLabel;
    IndRegsOvlyEdit: TEdit;
    IndRegsOvlyBtn: TButton;
    GroupBox9: TGroupBox;
    IndRegsEdit: TEdit;
    IndRegsBtn: TButton;
    BootScriptBox: TGroupBox;
    RunConnectRadBtn: TRadioButton;
    RunBootRadBtn: TRadioButton;
    RunNeverRadBtn: TRadioButton;
    Label29: TLabel;
    WriteWholePageChkBox: TCheckBox;
    Label30: TLabel;
    procedure ResetDTRRadBtnClick(Sender: TObject);
    procedure ResetRTSRadBtnClick(Sender: TObject);
    procedure ModeDTRRadBtnClick(Sender: TObject);
    procedure ModeRTSRadBtnClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure OKBtnClick(Sender: TObject);
    procedure AssociateBtnClick(Sender: TObject);
    procedure OpenFileBtnClick(Sender: TObject);
    procedure HelpBtnClick(Sender: TObject);
    procedure UpdateControls2(Sender: TObject);
    procedure RunRadBtnClick(Sender: TObject);
    procedure UpdateControls3(Sender: TObject);
    procedure MemEditKeyPress(Sender: TObject; var Key: Char);
    procedure BaudEditKeyPress(Sender: TObject; var Key: Char);
    procedure BaudUpDnClick(Sender: TObject; Button: TUDBtnType);
    procedure ClearAllMemBtnClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure WordWrap1Click(Sender: TObject);
    procedure PopupMenu1Popup(Sender: TObject);
    procedure EditCut1Execute(Sender: TObject);
    procedure EditCopy1Execute(Sender: TObject);
    procedure EditPaste1Execute(Sender: TObject);
    procedure PopupMenu2Popup(Sender: TObject);
    procedure WordWrap2Click(Sender: TObject);
    procedure EditCut2Execute(Sender: TObject);
    procedure EditCopy2Execute(Sender: TObject);
    procedure EditPaste2Execute(Sender: TObject);
    procedure MCUComboBoxDropUp(Sender: TObject);
    procedure XtalComboBoxDropUp(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  SettingsForm: TSettingsForm;

implementation

uses
  Main, InitUnit, CheckUnit, FileUnit, MemUnit, CFGUnit, Comms1, 
  SymbolUnit, MacroUnit, CalcUnit;
  
{$R *.DFM}

var
  SetData          : tProjDataRecord;
  SkipUpdate       : boolean;
  SkipOnChange     : boolean = false;
  MCUList,MCUData  : tStringList;

procedure ReadControls1(var Data : tProjDataRecord);
begin
  with Data,SettingsForm do
  begin
{General Tab};
    MCUType                     := MCUComboBox.Text;
    BytesToList                 := StrToInt(BytesToListEdit.Text);
    LinesToUnassemble           := StrToInt(LinesToUnassembleEdit.Text);
    AutoConnectAtStartUp        := AutoConnectChkBox.Checked;
    AutoResetAfterConnect       := AutoResetChkBox.Checked;
    WarnOnBprot                 := WarnOnBprotChkBox.Checked;
    WarnOnVprog                 := WarnOnVprogChkBox.Checked;
    NoBreakHandshake            := NoBreakHandshakeChkBox.Checked;
    IgnoreEchoErrors            := IgnoreEchoErrorsChkBox.Checked;
    FN_CtrlRegs                 := DeTokenizeFileName(RegInfoEdit.Text);
    FN_Opcodes                  := DeTokenizeFileName(OpcodeInfoEdit.Text);

{COM Port Tab};
    PortToUse                   := PortToUseComboBox.Text;
    CrystalFrequency            := XtalComboBox.Text;
    UploadBaudRate              := StrToInt(UploadBaudEdit.Text);
    CommsBaudRate               := StrToInt(CommsBaudEdit.Text);

    ResetUsesDTR                := ResetDTRRadBtn.Checked;
    ResetPulseGoesPos           := ResetPosRadBtn.Checked;

    IsSelectedWhenPos           := SelectedWhenPosRadBtn.Checked;

{Macros Tab};
    if RunNeverRadBtn.Checked    then RunBootScript := rbsNever;
    if RunConnectRadBtn.Checked  then RunBootScript := rbsConnect;
    if RunBootRadBtn.Checked     then RunBootScript := rbsBoot;

    BootScript                  := BootScriptMemo.Lines.Text;
    HasAssociatedMacro          := AssocMacroChkBox.Checked;
    NoAutoStart                 := NoAutoStartChkBox.Checked;
    AbortOnFormatError          := FormatAbortChkBox.Checked;
    AbortOnCmdFail              := FailureAbortChkBox.Checked;

{Debug Tab}
    AddBreakSpaces              := CodeBreakSpaceChkBox.Checked;
    NoVectorSubstitution        := NoVectorSubsChkBox.Checked;
    NotInStepOver               := NotInStepOverChkBox.Checked;
    ShowStartInst               := ShowStartInstChkBox.Checked;
    ShowStartRegs               := ShowStartRegsChkBox.Checked;
    ShowOnceOnly                := ShowOnceOnlyChkBox.Checked;
    ShowBreakInst               := ShowBreakInstChkBox.Checked;
    ShowBreakRegs               := ShowBreakRegsChkBox.Checked;

    if NoSymbolRadBtn.Checked then SymbolTableToUse := stNone;
    if AsS19RadBtn.Checked    then SymbolTableToUse := stAsS19;
    if FromFileRadBtn.Checked then SymbolTableToUse := stFromFile;

    FN_SymbolFixed := DeTokenizeFileName(SymbolFileEdit.Text);

{Talkers Tab};
    WaitForEcho    := WaitForEchoChkBox.Checked;
    FN_RamTalker   := DeTokenizeFileName(RamTalkerEdit.Text);
    FN_RamMap      := DeTokenizeFileName(RamMapEdit.Text);
    FN_EEMap       := DeTokenizeFileName(EepromMapEdit.Text);
    FN_ExtMap      := DeTokenizeFileName(ExternalMapEdit.Text);

{Overlays Tab}
    FN_EEOverlay        := DeTokenizeFileName(EepromOverlayEdit.Text);
    FN_EOverlay         := DeTokenizeFileName(EpromOverlayEdit.Text);
    FN_ByteWriteOverlay := DeTokenizeFileName(ByteWriteEdit.Text);
    FN_PageWriteOverlay := DeTokenizeFileName(PageWriteEdit.Text);

{Memory Map Tab};
    RamMem                      := RamEdit.Text;
    CtrlRegsMem                 := CtrlRegsEdit.Text;
    MaskRomMem                  := MaskRomEdit.Text;
    EepromMem                   := EepromEdit.Text;
    EpromMem                    := EpromMemo.Lines.Text;
    ExtRamMem                   := ExtRamMemo.Lines.Text;
    ByteWriteMem                := ByteWriteMemo.Lines.Text;
    PageWriteMem                := PageWriteMemo.Lines.Text;
    DataPageSize                := StrToInt(DataPageSizeComboBox.Text);
    MaskRomVisible              := MaskRomVisibleChkBox.Checked;
    EepromVisible               := EepromVisibleChkBox.Checked;
    EpromVisible                := EpromVisibleChkBox.Checked;
    ExtRamVisible               := ExtRamVisibleChkBox.Checked;
    ByteWriteVisible            := ByteWriteVisibleChkBox.Checked;
    PageWriteVisible            := PageWriteVisibleChkBox.Checked;
    WriteWholePage              := WriteWholePageChkBox.Checked;

{Notes Tab}
    Notes                       :=  NotesMemo.Lines.Text;

{Indirect Memory Tab}
    FN_IndRegs           := DeTokenizeFileName(IndRegsEdit.Text);
    IndMemory            := IndMemoryMemo.Lines.Text;
    IMVisible            := IMVisibleChkBox.Checked;
    IMPageSize           := StrToInt(IMPageSizeComboBox.Text);
    FN_IndMemOvly        := DeTokenizeFileName(IndMemOvlyEdit.Text);
    FN_IndRegsOvly       := DeTokenizeFileName(IndRegsOvlyEdit.Text);

  end; // with Data,SettingsForm do
end; // procedure ReadControls1

procedure ReadControls2(var Data : tProjDataRecord);
begin
  with Data,SettingsForm do
  begin
{COM Port Tab}
    RemoteResetAvailable  := RemoteResetChkBox.Checked;
    RemoteSwitchAvailable := RemoteSwitchChkBox.Checked;
  end; // with Data,SettingsForm do
end; // procedure ReadControls2

procedure ReadControls3(var Data : tProjDataRecord);
begin
  with Data,SettingsForm do
  begin
{Talkers Tab}
    if UseRamTalkerRadBtn.Checked      then TalkerType := ttRam;
    if UseEepromTalkerRadBtn.Checked   then TalkerType := ttEeprom;
    if UseExternalTalkerRadBtn.Checked then TalkerType := ttExternal;
    if ExtUsesRamBootRadBtn.Checked    then ExtTalkerRequires := ttRam;
    if ExtUsesEepromBootRadBtn.Checked then ExtTalkerRequires := ttEeprom;
    if ExtUsesNoBootRadBtn.Checked     then ExtTalkerRequires := ttNone;
  end; // with Data,SettingsForm do
end; // procedure ReadControls3

procedure WriteControls1(var Data : tProjDataRecord);
begin
  with Data,SettingsForm do
  begin
{General Tab}
    MCUComboBox.Text                 := MCUType;
    BytesToListEdit.Text             := IntToStr(BytesToList);
    LinesToUnassembleEdit.Text       := IntToStr(LinesToUnassemble);
    AutoConnectChkBox.Checked        := AutoConnectAtStartUp;
    AutoResetChkBox.Checked          := AutoResetAfterConnect;
    WarnOnBprotChkBox.Checked        := WarnOnBprot;
    WarnOnVprogChkBox.Checked        := WarnOnVprog;
    NoBreakHandshakeChkBox.Checked   := NoBreakHandshake;
    IgnoreEchoErrorsChkBox.Checked   := IgnoreEchoErrors;
    RegInfoEdit.Text                 := TokenizeFileName(FN_CtrlRegs);
    OpcodeInfoEdit.Text              := TokenizeFileName(FN_Opcodes);

{COM Port Tab}
    PortToUseComboBox.Text     := PortToUse;
    XtalComboBox.Text          := CrystalFrequency;
    UploadBaudEdit.Text        := IntToStr(UploadBaudRate);
    CommsBaudEdit.Text         := IntToStr(CommsBaudRate);

    ResetDTRRadBtn.Checked     := ResetUsesDTR;
    ResetRTSRadBtn.Checked     := not ResetUsesDTR;
    ResetPosRadBtn.Checked     := ResetPulseGoesPos;
    ResetNegRadBtn.Checked     := not ResetPulseGoesPos;

    SelectedWhenPosRadBtn.Checked  := IsSelectedWhenPos;
    SelectedWhenNegRadBtn.Checked  := not IsSelectedWhenPos;

{Macros Tab}
    case RunBootScript of
      rbsNever   : RunNeverRadBtn.Checked := true;
      rbsConnect : RunConnectRadBtn.Checked := true;
      rbsBoot    : RunBootRadBtn.Checked := true;
    end;
    BootScriptMemo.Lines.Text  := BootScript;
    AssocMacroChkBox.Checked   := HasAssociatedMacro;
    NoAutoStartChkBox.Checked  := NoAutoStart;
    FormatAbortChkBox.Checked  := AbortOnFormatError;
    FailureAbortChkBox.Checked := AbortOnCmdFail;

{Debug Tab}
    CodeBreakSpaceChkBox.Checked     := AddBreakSpaces;
    NoVectorSubsChkBox.Checked       := NoVectorSubstitution;
    NoVectorSubsChkBox.Enabled  := Prog.State in [psDuffData,psDisconnected,
                                                  psConnected,psStopped];
    NotInStepOverChkBox.Checked      := NotInStepOver;
    NotInStepOverChkBox.Enabled := Prog.State in [psDuffData,psDisconnected,
                                                  psConnected,psStopped];
    ShowStartInstChkBox.Checked      := ShowStartInst;
    ShowStartRegsChkBox.Checked      := ShowStartRegs;
    ShowOnceOnlyChkBox.Checked       := ShowOnceOnly;
    ShowBreakInstChkBox.Checked      := ShowBreakInst;
    ShowBreakRegsChkBox.Checked      := ShowBreakRegs;

    case SymbolTableToUse of
      stNone     : NoSymbolRadBtn.Checked := true;
      stAsS19    : AsS19RadBtn.Checked    := true;
      stFromFile : FromFileRadBtn.Checked := true;
    end; // case SymbolTableToUse of
//    AsS19Lbl.Caption := ExtractFileName(FN_SymbolAsS19);
    AsS19Lbl.Caption := ExtractFileName(FN_LoadS19);
    SymbolFileEdit.Text := TokenizeFileName(FN_SymbolFixed);

{Talkers Tab}
    WaitForEchoChkBox.Checked := WaitForEcho;
    RamTalkerEdit.Text        := TokenizeFileName(FN_RamTalker);
    RamMapEdit.Text           := TokenizeFileName(FN_RamMap);
    EepromMapEdit.Text        := TokenizeFileName(FN_EEMap);
    ExternalMapEdit.Text      := TokenizeFileName(FN_ExtMap);

{Overlays Tab}
    EepromOverlayEdit.Text    := TokenizeFileName(FN_EEOverlay);
    EpromOverlayEdit.Text     := TokenizeFileName(FN_EOverlay);
    ByteWriteEdit.Text        := TokenizeFileName(FN_ByteWriteOverlay);
    PageWriteEdit.Text        := TokenizeFileName(FN_PageWriteOverlay);

{Memory Map Tab}
    RamEdit.Text                   := RamMem;
    CtrlRegsEdit.Text              := CtrlRegsMem;
    MaskRomEdit.Text               := MaskRomMem;
    EepromEdit.Text                := EepromMem;
    EpromMemo.Lines.Text           := EpromMem;
    ExtRamMemo.Lines.Text          := ExtRamMem;
    ByteWriteMemo.Lines.Text       := ByteWriteMem;
    PageWriteMemo.Lines.Text       := PageWriteMem;
    DataPageSizeComboBox.Text      := IntToStr(DataPageSize);
    MaskRomVisibleChkBox.Checked   := MaskRomVisible;
    EepromVisibleChkBox.Checked    := EepromVisible;
    EpromVisibleChkBox.Checked     := EpromVisible;
    ExtRamVisibleChkBox.Checked    := ExtRamVisible;
    ByteWriteVisibleChkBox.Checked := ByteWriteVisible;
    PageWriteVisibleChkBox.Checked := PageWriteVisible;
    WriteWholePageChkBox.Checked   := WriteWholePage;

{Notes Tab}
    NotesMemo.Lines.Text           := Notes;

{Indirect Memory Tab}
    IndRegsEdit.Text               := TokenizeFileName(FN_IndRegs);
    IndMemoryMemo.Lines.Text       := IndMemory;
    IMVisibleChkBox.Checked        := IMVisible;
    IMPageSizeComboBox.Text        := IntToStr(IMPageSize);
    IndMemOvlyEdit.Text            := TokenizeFileName(FN_IndMemOvly);
    IndRegsOvlyEdit.Text           := TokenizeFileName(FN_IndRegsOvly);
  end; // with Data,SettingsForm do
end; // procedure WriteControls1

procedure WriteControls2(var Data : tProjDataRecord);
begin
  with Data,SettingsForm do
  begin
{COM Port Tab}
    RemoteResetChkBox.Checked  := RemoteResetAvailable;
    RemoteSwitchChkBox.Checked := RemoteSwitchAvailable;
  end; // with Data,SettingsForm do
end; // procedure WriteControls2

procedure WriteControls3(var Data : tProjDataRecord);
begin
  with Data,SettingsForm do
  begin
{Talkers Tab}
    UseRamTalkerRadBtn.Checked      := TalkerType = ttRam;
    UseEepromTalkerRadBtn.Checked   := TalkerType = ttEeprom;
    UseExternalTalkerRadBtn.Checked := TalkerType = ttExternal;
    ExtUsesRamBootRadBtn.Checked    := ExtTalkerRequires = ttRam;
    ExtUsesEepromBootRadBtn.Checked := ExtTalkerRequires = ttEeprom;
    ExtUsesNoBootRadBtn.Checked     := ExtTalkerRequires = ttNone;
  end; // with Data,SettingsForm do
end; // procedure WriteControls3

{Following WriteControls procedure duplicates other control writes, but is
 provided for use with the 'Use Defaults' button}
procedure WriteControls4(var Data : tProjDataRecord);
begin
  with Data,SettingsForm do
  begin
{General Tab}
    RegInfoEdit.Text              := TokenizeFileName(FN_CtrlRegs);
    OpcodeInfoEdit.Text           := TokenizeFileName(FN_Opcodes);
{Talkers Tab}
    RamTalkerEdit.Text            := TokenizeFileName(FN_RamTalker);
    RamMapEdit.Text               := TokenizeFileName(FN_RamMap);
    EepromOverlayEdit.Text        := TokenizeFileName(FN_EEOverlay);
    EpromOverlayEdit.Text         := TokenizeFileName(FN_EOverlay);
    ByteWriteEdit.Text            := '';
    PageWriteEdit.Text            := '';
    EepromMapEdit.Text            := TokenizeFileName(FN_EEMap);
    FN_ExtMap                     := '';
{Memory Map Tab}
    RamEdit.Text                  := RamMem;
    CtrlRegsEdit.Text             := CtrlRegsMem;
    MaskRomEdit.Text              := MaskRomMem;
    EepromEdit.Text               := EepromMem;
    EpromMemo.Lines.Text          := EpromMem;
    MaskRomVisibleChkBox.Checked  := MaskRomVisible;
    EepromVisibleChkBox.Checked   := EepromVisible;
    EpromVisibleChkBox.Checked    := EpromVisible;
  end; // with Data,SettingsForm do
end; // procedure WriteControls4

{*****************************************************************************}

procedure ResolveConflicts2(var Data : tProjDataRecord);
begin
  with Data,SettingsForm do
  begin
{General Tab}
    if not RemoteResetAvailable
    then AutoResetChkBox.Checked := false;
  end;
end; // procedure ResolveConflicts2

procedure EnableControls2(var Data : tProjDataRecord);
begin
  with Data,SettingsForm do
  begin
{General Tab}
    AutoResetChkBox.Enabled       := RemoteResetAvailable;
{COM Port Tab}
    Using1Lbl.Enabled             := RemoteResetAvailable;
    ResetDTRRadBtn.Enabled        := RemoteResetAvailable;
    ResetRTSRadBtn.Enabled        := RemoteResetAvailable;
    WithLbl.Enabled               := RemoteResetAvailable;
    ResetPosRadBtn.Enabled        := RemoteResetAvailable;
    PosPulseLbl.Enabled           := RemoteResetAvailable;
    ResetNegRadBtn.Enabled        := RemoteResetAvailable;
    NegPulseLbl.Enabled           := RemoteResetAvailable;

    Using2Lbl.Enabled             := RemoteSwitchAvailable;
    ModeDTRRadBtn.Enabled         := RemoteSwitchAvailable;
    ModeRTSRadBtn.Enabled         := RemoteSwitchAvailable;
    AltModeLbl.Enabled            := RemoteSwitchAvailable;
    WhenLbl.Enabled               := RemoteSwitchAvailable;
    SelectedWhenPosRadBtn.Enabled := RemoteSwitchAvailable;
    SelectedWhenNegRadBtn.Enabled := RemoteSwitchAvailable;
    IsPositiveLbl.Enabled         := RemoteSwitchAvailable;
    IsNegativeLbl.Enabled         := RemoteSwitchAvailable;
  end; // with Local,SettingsForm do
end; // procedure EnableControls2

{Controls on the Talkers Tab}
procedure EnableControls3(var Data : tProjDataRecord);
begin
  with Data,SettingsForm do
  begin
    RamTalkerLbl.Enabled        := (TalkerType = ttRam) or
      ((TalkerType = ttExternal) and (ExtTalkerRequires = ttRam));
    RamTalkerEdit.Enabled       := RamTalkerLbl.Enabled;
    RamTalkerBtn.Enabled        := RamTalkerLbl.Enabled;
    WaitForEchoChkBox.Enabled   := (TalkerType = ttRam);
    RamMapLbl.Enabled           := (TalkerType = ttRam);
    RamMapEdit.Enabled          := RamMapLbl.Enabled;
    RamMapBtn.Enabled           := RamMapLbl.Enabled;

    EepromMapLbl.Enabled        := (TalkerType = ttEeprom);
    EepromMapEdit.Enabled       := EepromMapLbl.Enabled;
    EepromMapBtn.Enabled        := EepromMapLbl.Enabled;

    ExternalMapLbl.Enabled      := (TalkerType = ttExternal);
    ExternalMapEdit.Enabled     := ExternalMapLbl.Enabled;
    ExternalMapBtn.Enabled      := ExternalMapLbl.Enabled;
    RequiresLbl.Enabled              := ExternalMapLbl.Enabled;
    ExtUsesRamBootRadBtn.Enabled     := ExternalMapLbl.Enabled;
    ExtUsesEepromBootRadBtn.Enabled  := ExternalMapLbl.Enabled;
    ExtUsesNoBootRadBtn.Enabled      := ExternalMapLbl.Enabled;
  end;
end; // procedure EnableControls3

procedure TSettingsForm.UpdateControls2(Sender: TObject);
begin
  if SkipUpdate then exit;
  ReadControls2(SetData);
  ResolveConflicts2(SetData);
  WriteControls2(SetData);
  EnableControls2(SetData);
end; // procedure TSettingsForm.UpdateControls2

procedure TSettingsForm.UpdateControls3(Sender: TObject);
begin
  if SkipUpdate then exit;
  ReadControls3(SetData);
  EnableControls3(SetData);
end; // procedure TSettingsForm.UpdateControls3

{****************************************************************************}

procedure TSettingsForm.FormCreate(Sender: TObject);
begin
  ReadLayout(ReadInRoot);
  MainForm.Show;
  MCUData := tStringList.Create;
  MCUList := tStringList.Create;
end; // procedure TSettingsForm.FormCreate

procedure TSettingsForm.FormDestroy(Sender: TObject);
begin
  WriteRegistry(WorkRoot);
  MCUData.Free;
  MCUList.Free;
end; // procedure TSettingsForm.FormDestroy

procedure TSettingsForm.FormShow(Sender: TObject);
var
  Buf : string;
  i   : integer;
begin
{Copy the settings variables from the global to the local}
  SetData := ProjData;
{Enable controls accordingly}
  SkipUpdate := true;
  WriteControls1(SetData);
  ResolveConflicts2(SetData);
  WriteControls2(SetData);
  EnableControls2(SetData);
  WriteControls3(SetData);
  EnableControls3(SetData);
  SkipUpdate := false;
  RunRadBtnClick(nil); // enable/disable the boot macro edit box
{Update the settings form caption}
  Buf := ExtractFileName(Prog.FN_Project);
  if Buf = '' then Buf := '(unnamed)';
  SettingsForm.Caption := 'Settings for: ' + Buf;
{Update various lists}
  PortToUseComboBox.Items.Assign(Ports);
  XtalComboBox.Items.Clear;
  for i := 0 to BaudArrayTop do XtalComboBox.Items.Add(BaudDefaults[i].Freq);
{Read in the MCU data}
  Buf := DetokenizeFileName(FN_MCUData);
  if FileExists(Buf)
  then begin
    MCUData.LoadFromFile(Buf);
    GetCFGSectionNames(MCUData,MCUList);
    MCUComboBox.Items.Assign(MCUList);
  end
  else begin
    MCUData.Clear;
    MCUList.Clear;
    MCUComboBox.Items.Clear;
  end;
end; // procedure TSettingsForm.FormShow

procedure TSettingsForm.ResetDTRRadBtnClick(Sender: TObject);
begin
  ModeRTSRadBtn.Checked := true;
  PosPulseLbl.Caption   := 'DTR';
  NegPulseLbl.Caption   := 'DTR';
end; // procedure TSettingsForm.ResetDTRRadBtnClick

procedure TSettingsForm.ResetRTSRadBtnClick(Sender: TObject);
begin
  ModeDTRRadBtn.Checked := true;
  PosPulseLbl.Caption   := 'RTS';
  NegPulseLbl.Caption   := 'RTS';
end; // procedure TSettingsForm.ResetRTSRadBtnClick

procedure TSettingsForm.ModeDTRRadBtnClick(Sender: TObject);
begin
  ResetRTSRadBtn.Checked         := true;
  SelectedWhenPosRadBtn.Caption  := 'DTR';
  SelectedWhenNegRadBtn.Caption  := 'DTR';
end; // procedure TSettingsForm.ModeDTRRadBtnClick

procedure TSettingsForm.ModeRTSRadBtnClick(Sender: TObject);
begin
  ResetDTRRadBtn.Checked := true;
  SelectedWhenPosRadBtn.Caption  := 'RTS';
  SelectedWhenNegRadBtn.Caption  := 'RTS';
end; // procedure TSettingsForm.ModeRTSRadBtnClick

function CommDataSame(var Data1,Data2 : tProjDataRecord) : boolean;
begin
  Result :=
  (Data1.PortToUse             = Data2.PortToUse            ) and
  (Data1.UploadBaudRate        = Data2.UploadBaudRate       ) and
  (Data1.CommsBaudRate         = Data2.CommsBaudRate        ) and
  (Data1.RemoteResetAvailable  = Data2.RemoteResetAvailable ) and
  (Data1.ResetUsesDTR          = Data2.ResetUsesDTR         ) and
  (Data1.ResetPulseGoesPos     = Data2.ResetPulseGoesPos    ) and
  (Data1.RemoteSwitchAvailable = Data2.RemoteSwitchAvailable) and
  (Data1.IsSelectedWhenPos     = Data2.IsSelectedWhenPos    );
end; // function CommDataSame

function ProjDataSame(var Data1,Data2 : tProjDataRecord) : boolean;
begin
  Result :=
{General Tab}
  (Data1.MCUType                      = Data2.MCUType                   ) and
  (Data1.BytesToList                  = Data2.BytesToList               ) and
  (Data1.LinesToUnassemble            = Data2.LinesToUnassemble         ) and
  (Data1.AutoConnectAtStartUp         = Data2.AutoConnectAtStartUp      ) and
  (Data1.AutoResetAfterConnect        = Data2.AutoResetAfterConnect     ) and
  (Data1.WarnOnBprot                  = Data2.WarnOnBprot               ) and
  (Data1.WarnOnVprog                  = Data2.WarnOnVprog               ) and
  (Data1.NoBreakHandshake             = Data2.NoBreakHandshake          ) and
  (Data1.IgnoreEchoErrors             = Data2.IgnoreEchoErrors          ) and
  (uppercase(Data1.FN_CtrlRegs)       = uppercase(Data2.FN_CtrlRegs)    ) and
  (uppercase(Data1.FN_Opcodes)        = uppercase(Data2.FN_Opcodes)     )  and

{COM Port Tab}
  (Data1.CrystalFrequency             = Data2.CrystalFrequency          ) and

{Macros Tab}
            (Data1.RunBootScript      = Data2.RunBootScript             ) and
  (uppercase(Data1.BootScript)        = uppercase(Data2.BootScript)     ) and
            (Data1.HasAssociatedMacro = Data2.HasAssociatedMacro        ) and
            (Data1.NoAutoStart        = Data2.NoAutoStart               ) and
            (Data1.AbortOnFormatError = Data2.AbortOnFormatError        ) and
            (Data1.AbortOnCmdFail     = Data2.AbortOnCmdFail            ) and

{Debug Tab}
  (Data1.AddBreakSpaces               = Data2.AddBreakSpaces            ) and
  (Data1.NoVectorSubstitution         = Data2.NoVectorSubstitution      ) and
  (Data1.NotInStepOver                = Data2.NotInStepOver             ) and
  (Data1.ShowStartInst                = Data2.ShowStartInst             ) and
  (Data1.ShowStartRegs                = Data2.ShowStartRegs             ) and
  (Data1.ShowOnceOnly                 = Data2.ShowOnceOnly              ) and
  (Data1.ShowBreakInst                = Data2.ShowBreakInst             ) and
  (Data1.ShowBreakRegs                = Data2.ShowBreakRegs             ) and
  (Data1.SymbolTableToUse             = Data2.SymbolTableToUse          ) and
  (uppercase(Data1.FN_SymbolFixed)    = uppercase(Data2.FN_SymbolFixed) ) and

{Talkers Tab}
  (Data1.TalkerType                  = Data2.TalkerType                 ) and
  (Data1.WaitForEcho                 = Data2.WaitForEcho                ) and
  (uppercase(Data1.FN_RamTalker)     = uppercase(Data2.FN_RamTalker)    ) and
  (uppercase(Data1.FN_RamMap)        = uppercase(Data2.FN_RamMap)       ) and
  (uppercase(Data1.FN_EEMap)         = uppercase(Data2.FN_EEMap)        ) and
  (uppercase(Data1.FN_ExtMap)        = uppercase(Data2.FN_ExtMap)       ) and
            (Data1.ExtTalkerRequires = Data2.ExtTalkerRequires          ) and

{Overlays Tab}
  (uppercase(Data1.FN_EEOverlay)     = uppercase(Data2.FN_EEOverlay)    ) and
  (uppercase(Data1.FN_EOverlay)      = uppercase(Data2.FN_EOverlay)     ) and
  (uppercase(Data1.FN_ByteWriteOverlay) = uppercase(Data2.FN_ByteWriteOverlay)) and
  (uppercase(Data1.FN_PageWriteOverlay) = uppercase(Data2.FN_PageWriteOverlay)) and

{Memory Map Tab}
  (uppercase(Data1.RamMem)          = uppercase(Data2.RamMem)           ) and
  (uppercase(Data1.CtrlRegsMem)     = uppercase(Data2.CtrlRegsMem)      ) and
  (uppercase(Data1.MaskRomMem)      = uppercase(Data2.MaskRomMem)       ) and
  (uppercase(Data1.EepromMem)       = uppercase(Data2.EepromMem)        ) and
  (uppercase(Data1.EpromMem)        = uppercase(Data2.EpromMem)         ) and
  (uppercase(Data1.ExtRamMem)       = uppercase(Data2.ExtRamMem)        ) and
  (uppercase(Data1.ByteWriteMem)    = uppercase(Data2.ByteWriteMem)     ) and
  (uppercase(Data1.PageWriteMem)    = uppercase(Data2.PageWriteMem)     ) and
  (Data1.MaskRomVisible             = Data2.MaskRomVisible              ) and
  (Data1.EepromVisible              = Data2.EepromVisible               ) and
  (Data1.EpromVisible               = Data2.EpromVisible                ) and
  (Data1.ExtRamVisible              = Data2.ExtRamVisible               ) and
  (Data1.ByteWriteVisible           = Data2.ByteWriteVisible            ) and
  (Data1.PageWriteVisible           = Data2.PageWriteVisible            ) and
  (Data1.DataPageSize               = Data2.DataPageSize                ) and
  (Data1.WriteWholePage             = Data2.WriteWholePage              ) and

{Indirect Memory Tab}
  (uppercase(Data1.FN_IndRegs)      = uppercase(Data2.FN_IndRegs)       ) and
  (uppercase(Data1.IndMemory)       = uppercase(Data2.IndMemory)        ) and
  (Data1.IMVisible                  = Data2.IMVisible                   ) and
  (Data1.IMPageSize                 = Data2.IMPageSize                  ) and
  (uppercase(Data1.FN_IndMemOvly)   = uppercase(Data2.FN_IndMemOvly)    ) and
  (uppercase(Data1.FN_IndRegsOvly)  = uppercase(Data2.FN_IndRegsOvly)   ) and

{Notes Tab}
  (Data1.Notes            = Data2.Notes);
end; // function ProgDataSame

procedure TSettingsForm.OKBtnClick(Sender: TObject);
var
  ErrMsgs                           : tStringList;
  Flag1,Flag2,Flag3                 : boolean;
{Temporary variables for checking}
  DummyPage                         : tOpcodeData;
  DummyCtrlRegs,DummySerialMemRegs  : tCtrlRegArray;
  DummyMemMap,DummyIndMemMap        : tList;
  DummyTalkArray                    : tTalkArray;
  DummyTalkerLen                    : integer;
  DummyMapData                      : tMapRecord;
begin
  ErrMsgs        := tStringList.Create;
  DummyMemMap    := tList.Create;
  DummyIndMemMap := tList.Create;
  fillchar(DummyPage,sizeof(DummyPage),0);
  ReadControls1(SetData);
  ReadControls2(SetData);
  ReadControls3(SetData);
  Flag1 := CommDataSame(ProjData,SetData);
  Flag2 := ProjDataSame(ProjData,SetData);
  Flag3 := (uppercase(SetData.FN_SymbolFixed) =
            uppercase(ProjData.FN_SymbolFixed)) and
           (SetData.SymbolTableToUse = ProjData.SymbolTableToUse) ;
  try
    if not ProjectDataOK(SetData,DummyPage,DummyPage,DummyPage,DummyPage,
                         DummyCtrlRegs,DummySerialMemRegs,
                         DummyMemMap,DummyIndMemMap,
                         DummyTalkArray,DummyTalkerLen,DummyMapData,ErrMsgs)
    then begin
      ErrMsgs.Insert(0,'''Settings'' is about to close with one or more errors:');
      ErrMsgs.Insert(1,'');
      ErrMsgs.Add('');
      ErrMsgs.Add('''OK'' to close anyway, ''Cancel'' to return to Settings');
      Case MessageDlg(ErrMsgs.Text,mtError,[mbOK,mbCancel,mbHelp],
                      IDH_SETTINGS_DIALOG) of
        mrOK     : begin
                     ProjData                 := SetData;
                     if (not Flag1) or (not Flag2)
                     then Prog.ProjectHasChanged := true;
                     Prog.State               := psDuffData;
                     SettingsForm.ModalResult := mrOK;
                   end;
        mrCancel : begin
                     SettingsForm.ModalResult := mrNone;
                   end;
      end; // case MessageDlg() of
    end // if not ProjectDataOK() then..
    else begin
      ProjData    := SetData;
      if (not Flag1) or (not Flag2)
      then Prog.ProjectHasChanged := true;
      ProjectDataOK(ProjData,OpcodePage1,OpcodePage2,OpcodePage3,OpcodePage4,
                    CtrlRegs,IndRegs,MemMap,IndMemMap,TalkArray,TalkerLen,MapData,ErrMsgs);
                    
      if not Flag3
      then begin
        OpenSymbolFile;
        if SymbolForm.Visible and SymbolForm.SymbolsBtn.Down
        then ShowSymbols;
      end;

      if (not Flag1) or (Prog.State = psDuffData)
      then Prog.State  := psDisconnected;
      SettingsForm.ModalResult := mrOK;
    end; // if not ProjectDataOK() then.. else..
  finally
    ErrMsgs.Free;
    DummyMemMap.Free;
    DummyIndMemMap.Free;
  end; // try.. finally..
end; // procedure TSettingsForm.OKBtnClick

procedure TSettingsForm.AssociateBtnClick(Sender: TObject);
begin
  SetupFileAssociation;
end;

procedure TSettingsForm.OpenFileBtnClick(Sender: TObject);
var
  Buf      : string;
  Edit     : tEdit;
  FileType : tFileType;
begin
  Edit     := nil;
  FileType := ftMacro;
{General Tab}
  if Sender = RegOpenBtn
  then begin
    Edit     := RegInfoEdit;
    FileType := ftCtrlRegs;
  end;
  if Sender = OpcodeOpenBtn
  then begin
    Edit     := OpcodeInfoEdit;
    FileType := ftOpcode;
  end;
{Debug Tab}
  if Sender = OpenSymbolBtn
  then begin
    Edit     := SymbolFileEdit;
    FileType := ftSymbol;
  end;
{Talkers Tab}
  if Sender = RamTalkerBtn
  then begin
    Edit     := RamTalkerEdit;
    FileType := ftTalker;
  end;
  if Sender = RamMapBtn
  then begin
    Edit     := RamMapEdit;
    FileType := ftMap;
  end;
  if Sender = EepromMapBtn
  then begin
    Edit     := EepromMapEdit;
    FileType := ftMap;
  end;
  if Sender = ExternalMapBtn
  then begin
    Edit     := ExternalMapEdit;
    FileType := ftMap;
  end;
{Overlays Tab}
  if Sender = EepromOverlayBtn
  then begin
    Edit     := EepromOverlayEdit;
    FileType := ftOverlay;
  end;
  if Sender = EpromOverlayBtn
  then begin
    Edit     := EpromOverlayEdit;
    FileType := ftOverlay;
  end;
  if Sender = ByteWriteBtn
  then begin
    Edit     := ByteWriteEdit;
    FileType := ftOverlay;
  end;
  if Sender = PageWriteBtn
  then begin
    Edit     := PageWriteEdit;
    FileType := ftOverlay;
  end;
{Ind Mem Tab}
  if Sender = IndRegsBtn
  then begin
    Edit     := IndRegsEdit;
    FileType := ftCtrlRegs;
  end;
  if Sender = IndMemOvlyBtn
  then begin
    Edit     := IndMemOvlyEdit;
    FileType := ftOverlay;
  end;
  if Sender = IndRegsOvlyBtn
  then begin
    Edit     := IndRegsOvlyEdit;
    FileType := ftOverlay;
  end;
  
  Buf := DeTokenizeFileName(Edit.Text);
  if OpenDialogOK(Buf,FileType) then Edit.Text := TokenizeFileName(Buf);
end; // procedure TSettingsForm.OpenFileBtnClick

procedure TSettingsForm.HelpBtnClick(Sender: TObject);
begin
  Application.HelpContext(IDH_SETTINGS_GENERAL +
                             ord(byte(PageControl1.ActivePage.PageIndex)));
end; // TSettingsForm.HelpBtnClick

procedure TSettingsForm.RunRadBtnClick(Sender: TObject);
begin
  BootScriptMemo.Enabled := not (RunNeverRadBtn.Checked);
end; // procedure TSettingsForm.BootScriptChkBoxClick

procedure TSettingsForm.MemEditKeyPress(Sender: TObject; var Key: Char);
begin
{Always allow the backspace, return and tab keys}
  if (Key = ^H) or (Key = ^M) or (Key = ^I) then exit;
  if not (Key in ['.','0'..'9','A'..'F','a'..'f']) then Key := chr(0);
end;

procedure TSettingsForm.BaudEditKeyPress(Sender: TObject;
  var Key: Char);
begin
{Always allow the backspace, return and tab keys}
  if (Key = ^H) or (Key = ^M) or (Key = ^I) then exit;
  if not (Key in DecChars) then Key := chr(0);
end;

procedure TSettingsForm.BaudUpDnClick(Sender: TObject; Button: TUDBtnType);
var
  EditBaud : integer;
  IsExact  : boolean;
  BaudText : string;
begin
  try
    if Sender = TkUpDn then BaudText := UploadBaudEdit.Text;
    if Sender = CoUpDn then BaudText := CommsBaudEdit.Text;
    if length(BaudText) = 0 then BaudText := '1';
    EditBaud := StrToInt(BaudText);
  except on EConvertError do exit;
  end;
  if Button = btNext
  then begin
    if (Sender = TkUpDn) and (EditBaud >= 57600) then exit;
    if (Sender = CoUpDn) and (EditBaud >= 115200) then exit;
    IsExact := EditBaud = 115200 div (115200 div EditBaud);
    if IsExact then EditBaud := EditBaud + 1;
    EditBaud := 115200 div (115200 div EditBaud);
  end;
  if Button = btPrev
  then begin
    if EditBaud <= 1 then exit;
    EditBaud := 115200 div ((115200 div EditBaud) + 1);
  end;
  if Sender = TkUpDn then UploadBaudEdit.Text := IntToStr(EditBaud);
  if Sender = CoUpDn then CommsBaudEdit.Text := IntToStr(EditBaud);
end; // procedure TSettingsForm.BaudUpDnClick

procedure TSettingsForm.ClearAllMemBtnClick(Sender: TObject);
begin
  RamEdit.Clear;
  CtrlRegsEdit.Clear;
  MaskRomEdit.Clear;
  EepromEdit.Clear;
  EpromMemo.Clear;
  ExtRamMemo.Clear;
  ByteWriteMemo.Clear;
  PageWriteMemo.Clear;
end; // procedure TSettingsForm.ClearAllMemBtnClick

procedure TSettingsForm.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  if MapForm.Visible then MapForm.FormShow(nil);
end;

procedure TSettingsForm.WordWrap1Click(Sender: TObject);
begin
  BootScriptMemo.WordWrap := not BootScriptMemo.WordWrap
end; // procedure TSettingsForm.WordWrap1Click

procedure TSettingsForm.WordWrap2Click(Sender: TObject);
begin
  NotesMemo.WordWrap := not NotesMemo.WordWrap
end;

procedure TSettingsForm.PopupMenu1Popup(Sender: TObject);
begin
  WordWrap1.Checked := BootScriptMemo.WordWrap;
end; // procedure TSettingsForm.PopupMenu1Popup

procedure TSettingsForm.PopupMenu2Popup(Sender: TObject);
begin
  WordWrap2.Checked := NotesMemo.WordWrap;
end;

procedure TSettingsForm.EditCut1Execute(Sender: TObject);
begin
  BootScriptMemo.CutToClipboard;
end; // procedure TSettingsForm.EditCut1Execute

procedure TSettingsForm.EditCopy1Execute(Sender: TObject);
begin
  BootScriptMemo.CopyToClipboard;
end; // procedure TSettingsForm.EditCopy1Execute

procedure TSettingsForm.EditPaste1Execute(Sender: TObject);
begin
  BootScriptMemo.PasteFromClipboard;
end; // procedure TSettingsForm.EditPaste1Execute

procedure TSettingsForm.EditCut2Execute(Sender: TObject);
begin
  NotesMemo.CutToClipboard;
end; // procedure TSettingsForm.EditCut2Execute

procedure TSettingsForm.EditCopy2Execute(Sender: TObject);
begin
  NotesMemo.CopyToClipboard;
end; // procedure TSettingsForm.EditCopy2Execute

procedure TSettingsForm.EditPaste2Execute(Sender: TObject);
begin
  NotesMemo.PasteFromClipboard;
end; // procedure TSettingsForm.EditPaste2Execute

procedure TSettingsForm.MCUComboBoxDropUp(Sender: TObject);
begin
  if length(MCUComboBox.Text) > 0
  then begin
    SetData.MCUType := MCUComboBox.Text;
    ReadMCUDataFile(MCUData,uppercase(MCUComboBox.Text),SetData);
    WriteControls4(SetData);
  end;
end; // procedure TSettingsForm.MCUComboBoxDropUp

procedure TSettingsForm.XtalComboBoxDropUp(Sender: TObject);
var
  i   : integer;
  Buf : string;
begin
  Buf := XtalComboBox.Text;
  i   := 0;
  while (i <= BaudArrayTop) and (Buf <> XtalComboBox.Items[i]) do i := i + 1;
  if (i <= BaudArrayTop)
  then begin
    UploadBaudEdit.Text := BaudDefaults[i].TalkerUpload;
    CommsBaudEdit.Text  := BaudDefaults[i].Communication;
    if length(BaudDefaults[i].AltUpload) > 0
    then begin
      if MessageDlg('An alternative, faster, rate is available for talker upoad.' + CRLF +
                    'Try this rate?',
                    mtConfirmation,[mbYes,mbNo,mbHelp],
                    IDH_SETTINGS_COM_PORT) = mrYes
      then begin
        UploadBaudEdit.Text := BaudDefaults[i].AltUpload;
      end;
    end;
  end;
end; // procedure TSettingsForm.XtalComboBoxDropUp

end.

