var

  PFList : tStringList;

const
  FN_Help = 'JBug11.hlp';
  LaunchDirToken : string = '[JBug11]';
  LaunchDirFull  : string = '';
  MyDocsDirToken : string = '[MyDocs]';
  MyDocsDirFull  : string = '';

type
  tFileType = (ftProject,ftCtrlRegs,ftOpcode,ftTalker,ftMap,ftOverlay,ftS19,ftBinary,
               ftSymbol,ftMacro,ftErrRpt,ftLog,ftImage);
  tFileTypeSet = set of tFileType;
  tFileTypeArray = array[tFileType] of string;

const
  tdDefName : tFileTypeArray =
  ( '[JBug11]\Project\',
    '[JBug11]\Registers\',
    '[JBug11]\Opcodes\',
    '[JBug11]\Talkers\',
    '[JBug11]\Talkers\',
    '[JBug11]\Talkers\',
    '[MyDocs]',
    '[MyDocs]',
    '[MyDocs]',
    '[MyDocs]',
    '[JBug11]\User\',
    '[MyDocs]',
    '[MyDocs]');

  tdDefExt : tFileTypeArray =
  ( 'jbp',
    'csv',
    'csv',
    'BOO',
    'map',
    'S19',
    'S19',
    'obj',
    'sym',
    'mcr',
    'txt',
    'log',
    'bin');

  tdFilter : tFileTypeArray =
  ( 'JBug11 Project files (*.jbp)|*.jbp|All files (*.*)|*.*',
    'Control register files|*.csv',
    'Opcode information files|*.csv',
    'Talker files (*.BOO,*.XOO)|*.BOO;*.XOO|All files (*.*)|*.*',
    'Talker map files (*.map)|*.map|All files (*.*)|*.*',
    'Talker overlay files (*.rec)|*.rec|All files (*.*)|*.*',
    'S19 files (*.S19,*.rec)|*.S19;*.rec|All files (*.*)|*.*',
    'Binary files (*.obj,*.bin)|*.obj;*.bin|All files (*.*)|*.*',
    'Symbol files (*.sym)|*.sym|All files (*.*)|*.*',
    'Macro files (*.mcr)|*.mcr|Text files (*.txt)|*.txt|All files (*.*)|*.*',
    'Text files (*.txt)|*.txt|All files (*.*)|*.*',
    'Log files (*.log)|*.log|All files (*.*)|*.*',
    'Binary image files (*.bin,*.obj)|*.bin;*.obj|All files (*.*)|*.*');

  tdCaption : tFileTypeArray =
  ( 'Project',
    'Control Registers',
    'Opcode Information',
    'Talker',
    'Talker Map',
    'Talker Overlay',
    'S19 File',
    'Binary File',
    'Symbol Table',
    'Macro',
    'Error Report',
    'Terminal Log',
    'Binary Image');

